package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Alignment {

public final static byte LEFT = 0;
public final static byte CENTER = 1;
public final static byte RIGHT = 2;
public final static byte UNDEFINED = 3;

public static short GetOffsetX (byte align, short rectSizeX, short strSizeX) {


	 short offsetX = 0;

	if(align != LEFT)
	{
		offsetX = (short)(rectSizeX - strSizeX);
		if(align == CENTER)
		{
			offsetX >>= 1;
		}
	}
	return  offsetX;

}



/* One dimension array */
public static Alignment[] InstArrayAlignment(int size) {
	Alignment[] newArray = new Alignment[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Alignment();
	return newArray; }

/* Two dimension array */
public static Alignment[][] InstArrayAlignment(int size1, int size2) {
	Alignment[][] newArray = new Alignment[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Alignment[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Alignment(); }
	return newArray; }

/* Three dimension array */
public static Alignment[][][] InstArrayAlignment(int size1, int size2, int size3) {
	Alignment[][][] newArray = new Alignment[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Alignment[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Alignment[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Alignment(); } }
	return newArray; }

public Alignment () { 
}




}

