package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class BoundsSide {

public final static byte Inside = 1;
public final static byte Outside = -1;
public final static byte BothSides = 0;


/* One dimension array */
public static BoundsSide[] InstArrayBoundsSide(int size) {
	BoundsSide[] newArray = new BoundsSide[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new BoundsSide();
	return newArray; }

/* Two dimension array */
public static BoundsSide[][] InstArrayBoundsSide(int size1, int size2) {
	BoundsSide[][] newArray = new BoundsSide[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new BoundsSide[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new BoundsSide(); }
	return newArray; }

/* Three dimension array */
public static BoundsSide[][][] InstArrayBoundsSide(int size1, int size2, int size3) {
	BoundsSide[][][] newArray = new BoundsSide[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new BoundsSide[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new BoundsSide[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new BoundsSide(); } }
	return newArray; }

public BoundsSide () { 
}




}

