package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class DisplayManagerAPI {

public final static byte apiNone = 0;
public final static byte apiGDI = 1;
public final static byte apiGAPI = 2;
public final static byte apiSymbian = 3;
public final static byte apiMac = 4;
public final static byte apiBrew = 5;
public final static byte apiOpenGL = 6;
public final static byte apiDirectX = 7;
public final static byte apiJ2ME = 8;
public final static byte apiNGage = 9;


/* One dimension array */
public static DisplayManagerAPI[] InstArrayDisplayManagerAPI(int size) {
	DisplayManagerAPI[] newArray = new DisplayManagerAPI[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new DisplayManagerAPI();
	return newArray; }

/* Two dimension array */
public static DisplayManagerAPI[][] InstArrayDisplayManagerAPI(int size1, int size2) {
	DisplayManagerAPI[][] newArray = new DisplayManagerAPI[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new DisplayManagerAPI[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new DisplayManagerAPI(); }
	return newArray; }

/* Three dimension array */
public static DisplayManagerAPI[][][] InstArrayDisplayManagerAPI(int size1, int size2, int size3) {
	DisplayManagerAPI[][][] newArray = new DisplayManagerAPI[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new DisplayManagerAPI[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new DisplayManagerAPI[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new DisplayManagerAPI(); } }
	return newArray; }

public DisplayManagerAPI () { 
}




}

