package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class FrameRate {

public FrameRate () {




}


public void Reset () {

	mLastTime = 0;
	mLastFrameRateTimes100 = 0;

}


public void AdvanceFrame () {

	 int currentTime = Application.GetRealTime();


	 int elapsed = currentTime - mLastTime;


	if(elapsed > 0)
	{
		mLastFrameRateTimes100 = 100000/ elapsed;
	}
	else
	{
		mLastFrameRateTimes100 = 0;
	}


	mLastTime = currentTime;

}


public int GetRateTimes100 () {

	return  mLastFrameRateTimes100;

}


public int mLastTime;
public int mLastFrameRateTimes100;

/* One dimension array */
public static FrameRate[] InstArrayFrameRate(int size) {
	FrameRate[] newArray = new FrameRate[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new FrameRate();
	return newArray; }

/* Two dimension array */
public static FrameRate[][] InstArrayFrameRate(int size1, int size2) {
	FrameRate[][] newArray = new FrameRate[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FrameRate[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new FrameRate(); }
	return newArray; }

/* Three dimension array */
public static FrameRate[][][] InstArrayFrameRate(int size1, int size2, int size3) {
	FrameRate[][][] newArray = new FrameRate[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FrameRate[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new FrameRate[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new FrameRate(); } }
	return newArray; }



}

