package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class FrameworkGlobals {

public FrameworkGlobals() {

mPackageLoader = new PackageLoader();



}


public void destruct() {
  Delete(); 
}


public void Delete () {




}


public static FrameworkGlobals GetInstance () {

	

return  FlAndroidApp.frameworkGlobals;
	





}


public static void SetUserInputEnabled (boolean boIsEnabled) {

	if(boIsEnabled)
	{

		--FrameworkGlobals.GetInstance().userInputDisabled;
	}
	else
	{
		++FrameworkGlobals.GetInstance().userInputDisabled;
	}

}


public static boolean IsUserInputEnabled () {

	return  (FrameworkGlobals.GetInstance().userInputDisabled == 0);

}


public Application application;
public SoundManager soundManager;
public FlPowerManager mFlPowerManager;
public Component penTracker;
public VibrationManager vibrationManager;
public int userInputDisabled;
public int randomState;
public PackageLoader mPackageLoader;
public FlPenManager mFlPenManager;
public FlAccelerometer mFlAccelerometer;
public FlBrowser mFlBrowser;
public FlGameTimer mFlGameTimer;
public FlEventQueue mFlEventQueue;

/* One dimension array */
public static FrameworkGlobals[] InstArrayFrameworkGlobals(int size) {
	FrameworkGlobals[] newArray = new FrameworkGlobals[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new FrameworkGlobals();
	return newArray; }

/* Two dimension array */
public static FrameworkGlobals[][] InstArrayFrameworkGlobals(int size1, int size2) {
	FrameworkGlobals[][] newArray = new FrameworkGlobals[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FrameworkGlobals[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new FrameworkGlobals(); }
	return newArray; }

/* Three dimension array */
public static FrameworkGlobals[][][] InstArrayFrameworkGlobals(int size1, int size2, int size3) {
	FrameworkGlobals[][][] newArray = new FrameworkGlobals[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FrameworkGlobals[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new FrameworkGlobals[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new FrameworkGlobals(); } }
	return newArray; }



}

