package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Package {

public static Package Cast(Object o, Package _) {
 return  (Package)o; 
}


 final public static byte typeNumber = TypeIDOfType_Package.v;
 final public static byte typeID = TypeIDOfType_Package.w;
 public static final boolean supportsDynamicSerialization = false; public void OnSerialize(Package a125) {
 
}


public final static int notInFile = 0xffffffff;
public final static int fromPackage = 0xfffffffe;

public final static byte unloaded = 0;
public final static byte initializingFileStream = 1;
public final static byte uncompressing = 2;
public final static byte initializingEntryPoints = 3;
public final static byte loadingEntryPoints = 4;
public final static byte loadingSoundFX = 5;
public final static byte loaded = 6;

public  Package () {
mLoadingState = (unloaded);






























































}


public Package ( Package other) {



mLoadingState = other.mLoadingState;
	mStream = other.mStream;
	mFilePositionIndex = other.mFilePositionIndex;


mPackageType = other.mPackageType;

	mNumPackageDependencies = other.mNumPackageDependencies;
	mPackageDependencies = other.mPackageDependencies;

	mNumEntryPoints = other.mNumEntryPoints;
	mEntryPoints = other.mEntryPoints;
	mNextEntryPointIdx = other.mNextEntryPointIdx;








mLoadingEntryPointIndex = other.mLoadingEntryPointIndex;
	mNextObjectNumber = other.mNextObjectNumber;
	mNumInternalObjects = other.mNumInternalObjects;
	mInternalObjects = other.mInternalObjects;

	mIsBeingUnloaded = other.mIsBeingUnloaded;




}


public void destruct() {








}


public void StartImmediateStreamReading (LibraryStream stream) {

	mStream = stream;

}


public void SetNumDependencies (int numDependencies) {

	mNumPackageDependencies = numDependencies;


	
	mPackageDependencies = new Package[mNumPackageDependencies];
	



}


public void SetDependency (int dependencyNum, Package dependency) {


	mPackageDependencies[dependencyNum] = dependency;

}


public void Load (boolean asynchronous) {




if(asynchronous)
	{
		
		FrameworkGlobals.GetInstance().mPackageLoader.InsertPackageInQueue(this);
	}
	else
	{
		

		
		for(int i = 0;i < GetNumPackageDependencies();i ++)
		{

		}

		SetLoadingState(initializingFileStream);
		LoadFromQueue();		
	}

}


public void Load (LibraryStream stream) {



SetLoadingState(initializingFileStream);
	SyncLoad(stream);

}


public void SetNextEntryPointIndex (int index) {

	mNextEntryPointIdx = index;

}


public int GetNextEntryPointIndex () {

	return  mNextEntryPointIdx;

}


public void Unload () {






if(IsLoading())
	{
		FrameworkGlobals.GetInstance().mPackageLoader.RemovePackageFromQueue(this);

	


SetLoadingState(unloaded);
		return ;
}





































mEntryPoints = null;

	




SetLoadingState(unloaded);

}


public boolean IsLoaded () {

	return  GetLoadingState() == loaded;

}


public boolean IsLoading() {
 return  (mLoadingState != loaded && mLoadingState != unloaded); 
}


public static void SetGCOnLoadPackage(boolean status) {
 gcOnLoadPackageEnabled = status; 
	
}


public boolean IsWriting() {
 return  false; 
}


public boolean IsReading() {
 return  true; 
}


public int GetFilePosition () {

	return  ((LibraryStream)mStream).GetPosition();

}


public void SkipBytes (int numBytes) {

	mStream.Skip(numBytes);

}


public Object GetEntryPoint (int index) {

	if(index == -1)
	{
		index = mNextEntryPointIdx ++;
	}

	return  mEntryPoints[index];

}


public boolean GetEntryPoint(int index, boolean [] a128) {
 
		return ((Boolean) GetEntryPoint(index)).booleanValue();
		
	
}


public byte GetEntryPoint(int index, byte [] a130) {
 
		return ((Byte) GetEntryPoint(index)).byteValue();
		
	
}


public short GetEntryPoint(int index, short [] a132) {
 
		return ((Short) GetEntryPoint(index)).shortValue();
		
	
}


public int GetEntryPoint(int index, int [] a134) {
 
		return ((Integer) GetEntryPoint(index)).intValue();
		
	
}


public int GetEntryPointCount() {
 return  mNumEntryPoints;
	
}


public Object SerializePointer (byte staticTypeID, boolean dynamic, boolean entryPoint) {


	return  ReadObjectPointer(staticTypeID, dynamic, entryPoint);






























}


public byte ReadByte() {
 return  mStream.ReadByte();
		
}


public int ReadLong() {
 return  mStream.ReadLong();
		
}


public boolean SerializeIntrinsic(boolean t) {
 ForceInline.v();
			return  SerializeIntrinsicBool();
		
}


public boolean SerializeIntrinsicBool() {
 ForceInline.v();
			 byte b = ReadByte();

			return  (b != 0);
		
}


public F32 SerializeIntrinsic (F32 t) {

		return  new F32(ReadLong());
	
}


public short SerializeShortWithEncoding () {




 byte b = 0;

		int s;

{	
			b = SerializeIntrinsic(b);
			s = (int)b >> 1;
			if((b & 1) != 0) 
			{
				b = SerializeIntrinsic(b);
				s = s & 0x7f| (((int)b << 6) & ~0x7f);
				if((b & 1) != 0) 
				{
					b = SerializeIntrinsic(b);
					s = s & 0x3fff| (((int)b << 13) & ~0x3fff);
				}
			}
			return  (short)s;
		}
	
}


public byte SerializeIntrinsic(byte t) {
 ForceInline.v(); return  SerializeIntrinsicByte(); 
}


public byte SerializeIntrinsicByte() {
 ForceInline.v(); return  ReadByte(); 
}


public short SerializeIntrinsic(short t) {
 ForceInline.v(); return  SerializeIntrinsicShort(); 
}


public short SerializeIntrinsicShort() {
 ForceInline.v(); return  SerializeShortWithEncoding(); 
}


public int SerializeIntrinsic(int t) {
 ForceInline.v(); return  SerializeIntrinsicLong(); 
}


public int SerializeIntrinsicLong() {
 ForceInline.v(); return  ReadLong(); 
}


public boolean [] SerializeIntrinsics(boolean [] t, int count) {
 ForceInline.v(); return  SerializeIntrinsicsBools(count);  
}


public byte [] SerializeIntrinsics(byte [] t, int count) {
 ForceInline.v(); return  SerializeIntrinsicsBytes(count);  
}


public short [] SerializeIntrinsics(short [] t, int count) {
 ForceInline.v(); return  SerializeIntrinsicsShorts(count); 
}


public int [] SerializeIntrinsics(int [] t, int count) {
 ForceInline.v(); return  SerializeIntrinsicsLongs(count);  
}


public boolean [] SerializeIntrinsicsBools (int count) {

			 byte[] buffer = new byte[count * LibraryStream.kSizeOfReadByte];
			mStream.Read(buffer, 0, count * LibraryStream.kSizeOfReadByte);
			 boolean[] t = new boolean[count];
			for(int i = 0;i < count;i ++)
				t[i] = (buffer[i] != 0);
			buffer = null;
			return  t;
		
}


public byte [] SerializeIntrinsicsBytes (int count) {

		 byte[] t = new byte[count];
		mStream.Read(t, 0, count);
		return  t;
	
}


public short [] SerializeIntrinsicsShorts (int count) {

	































 short[] t = new short[count];
		for(int i = 0;i < count;i ++)
		{
			t[i] = SerializeShortWithEncoding();
		}
		return  t;
	


}


public int [] SerializeIntrinsicsLongs (int count) {

		 byte[] buffer = new byte[count * LibraryStream.kSizeOfReadInt];
		mStream.Read(buffer, 0, count * LibraryStream.kSizeOfReadInt);
		 int[] t = new int[count];
		for(int i = 0, offset = 0, max = count << 2;offset < max;i ++)
		{
			t[i] = (int) ((buffer[offset++] << 24) | ((buffer[offset++] & 0xff) << 16) |
				((buffer[offset++] & 0xff) << 8) | (buffer[offset++] & 0xff));
		}

		buffer = null;
		return  t;
	
}


public Package [] GetPackageDependencies() {
 return  mPackageDependencies; 
}


public int GetNumPackageDependencies() {
 return  mNumPackageDependencies; 
}


public void StartLoading() {
 ; mLoadingState = initializingFileStream; 
}


public void SyncLoad (LibraryStream stream) {



	mStream = stream;


	 boolean mCompressed = false;
 
if(GetLoadingState() == initializingFileStream)
	{








(mCompressed)= (this).SerializeIntrinsic(mCompressed);
		SetLoadingState(mCompressed ? uncompressing : initializingEntryPoints);		
	}







































 int numEntryPoints = 0;


	if(GetLoadingState() == initializingEntryPoints)
	{
		
		 int numPackageDependencies = 0;

		(numPackageDependencies)= (this).SerializeIntrinsic(numPackageDependencies);


		 int dependencyNum__end = numPackageDependencies;
  int dependencyNum = 0;
 for(;dependencyNum <dependencyNum__end;dependencyNum ++)
		{
			 short dependencyPackageType = (0);

			(dependencyPackageType)= (this).SerializeIntrinsic(dependencyPackageType);





}

		(numEntryPoints)= (this).SerializeIntrinsic(numEntryPoints);
		SetNumEntryPoints(numEntryPoints);





(mNumInternalObjects)= (this).SerializeIntrinsic(mNumInternalObjects);


		mInternalObjects = new Object[mNumInternalObjects];


mNextObjectNumber = 0;
		mLoadingEntryPointIndex = 0;





SetLoadingState(loadingEntryPoints);
	}

	if(GetLoadingState() == loadingEntryPoints)
	{



for(;mLoadingEntryPointIndex < numEntryPoints;mLoadingEntryPointIndex ++)
		{


mEntryPoints[mLoadingEntryPointIndex] = (Object)SerializePointer((byte)(byte)0, true, true);
}

		mNextEntryPointIdx = 0;



mInternalObjects = null;







{
			SetLoadingState(loaded);
		}
	}









mStream = null;

}


public void LoadFromQueue () {

	 Library library = mLibrary;


	library.Open();
	 LibraryStream stream = library.mStream;

	if(GetLoadingState() == initializingFileStream)
	{













stream.SetPosition(library.mFilePositions[mFilePositionIndex]);
	}

	SyncLoad(stream);

	







}


public Object ReadObjectPointer (byte staticTypeID, boolean dynamic, boolean entryPoint) {

	 short objectReference = 0;

	(objectReference)= (this).SerializeIntrinsic(objectReference);

	
	if(objectReference == 0)
	{

		return  ReadObject(staticTypeID, dynamic, entryPoint);




}



if(objectReference == 1)
	{
		return  null;
	}

	objectReference -= 2;

	
	 int dependencyNum__end = mNumPackageDependencies;
  int dependencyNum = 0;
 for(;dependencyNum <dependencyNum__end;dependencyNum ++)
	{
		 Package dependency = mPackageDependencies[dependencyNum];
		if(dependency == null) continue;

		if(objectReference < dependency.mNumEntryPoints)
		{
			
			

			return  dependency.mEntryPoints[objectReference];
		}

		objectReference = (short)(objectReference - dependency.mNumEntryPoints);
	}

	
	if(objectReference < mNumInternalObjects)
	{
		return  mInternalObjects[objectReference];
	}
	


	return  null;

}


public Object ReadObject (byte staticTypeID, boolean dynamicLoad, boolean entryPoint) {



	 byte typeID = staticTypeID;

	if(dynamicLoad)
	{
		(typeID)= (this).SerializeIntrinsic(typeID);
	}

	 int thisObjectIndex = mNextObjectNumber ++;

	return  (mInternalObjects[thisObjectIndex] = ObjectReader.Read(this, typeID));

}


public boolean IsBeingUnloaded () {

	return  mIsBeingUnloaded;

}


public byte GetLoadingState() {
 return  mLoadingState; 
}


public void SetLoadingState(byte loadingState) {
 mLoadingState = loadingState; 
}


public void SetNumEntryPoints (int numEntryPoints) {

	mNumEntryPoints = numEntryPoints;


	mEntryPoints = new Object[numEntryPoints];






}


public int ReadBufferAtOffset(byte [] buffer, int offset, int size) {
 return  mStream.Read(buffer, offset, size);
		
}


public Library mLibrary;
public LibraryStream mStream;
public short mFilePositionIndex;
public short mPackageType;
public int mNumPackageDependencies;

	public Package[] mPackageDependencies;
	public int mNumEntryPoints;
public byte mLoadingState;

	public Object[] mEntryPoints;
	public Object[] mInternalObjects;
	public int mLoadingEntryPointIndex;
public int mNextObjectNumber;
public int mNumInternalObjects;
public int mNextEntryPointIdx;
public boolean mIsBeingUnloaded;

	public static final boolean staticbool  = false;
	public static final byte	staticByte	= 0;
	public static final short	staticshort	= 0;
	public static final int		staticlong  = 0;
	public static final F32		staticF32   = new F32();
	public static boolean gcOnLoadPackageEnabled = true;
public void Load()
{
	Load(false);
}

/* One dimension array */
public static Package[] InstArrayPackage(int size) {
	Package[] newArray = new Package[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Package();
	return newArray; }

/* Two dimension array */
public static Package[][] InstArrayPackage(int size1, int size2) {
	Package[][] newArray = new Package[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Package[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Package(); }
	return newArray; }

/* Three dimension array */
public static Package[][][] InstArrayPackage(int size1, int size2, int size3) {
	Package[][][] newArray = new Package[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Package[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Package[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Package(); } }
	return newArray; }



}

