package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class RepalettizedBitmap extends BitmapImplementor {

public static RepalettizedBitmap Cast(Object o, RepalettizedBitmap _) {
 return  (RepalettizedBitmap)o; 
}


 final public static byte typeNumber = TypeIDOfType_RepalettizedBitmap.v;
 final public static byte typeID = TypeIDOfType_RepalettizedBitmap.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public RepalettizedBitmap () {


}


public RepalettizedBitmap (Bitmap sourceBitmap, Palette palette) {

	CreateRepalettizedBitmap(sourceBitmap, palette);
	mSourceBitmap = sourceBitmap;
	mData = null;

}


public void destruct() {


}


public void CreateRepalettizedBitmap (Bitmap sourceBitmap, Palette palette) {





CreateImageForRepalettization(sourceBitmap, palette);

}


public void OnSerialize (Package p) {

	 Bitmap sourceBitmap = null;
	(sourceBitmap)= sourceBitmap.Cast((p).SerializePointer((sourceBitmap).typeNumber, (sourceBitmap).supportsDynamicSerialization, false), null);
	CloneAttributes(sourceBitmap);


	(mIsBlendingColor)= (p).SerializeIntrinsic(mIsBlendingColor);

	if(IsBlendingColor())
	{
		(mBlendingColor).OnSerialize(p);
	}
if(!mIsBlendingColor)
{
		 Palette palettePointer = null;
		(palettePointer)= palettePointer.Cast((p).SerializePointer((palettePointer).typeNumber, (palettePointer).supportsDynamicSerialization, false), null);

		CreateRepalettizedBitmap(sourceBitmap, palettePointer);
	}

	mSourceBitmap = sourceBitmap;




}


public void SetPalette ( Palette newPalette) {

	CreateRepalettizedBitmap(mSourceBitmap, newPalette);

}


public Bitmap mSourceBitmap;

/* One dimension array */
public static RepalettizedBitmap[] InstArrayRepalettizedBitmap(int size) {
	RepalettizedBitmap[] newArray = new RepalettizedBitmap[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new RepalettizedBitmap();
	return newArray; }

/* Two dimension array */
public static RepalettizedBitmap[][] InstArrayRepalettizedBitmap(int size1, int size2) {
	RepalettizedBitmap[][] newArray = new RepalettizedBitmap[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new RepalettizedBitmap[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new RepalettizedBitmap(); }
	return newArray; }

/* Three dimension array */
public static RepalettizedBitmap[][][] InstArrayRepalettizedBitmap(int size1, int size2, int size3) {
	RepalettizedBitmap[][][] newArray = new RepalettizedBitmap[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new RepalettizedBitmap[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new RepalettizedBitmap[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new RepalettizedBitmap(); } }
	return newArray; }



}

