package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Shape extends Component {

public static Shape Cast(Object o, Shape _) {
 return  (Shape)o; 
}


 final public static byte typeNumber = TypeIDOfType_Shape.v;
 final public static byte typeID = TypeIDOfType_Shape.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public final static byte RECTANGLE = 0;

public  Shape () {
super();
mOpacity = (255);
mColor = new Color888();



}


public  Shape (Viewport viewport) {
super();
mOpacity = (255);
mColor = new Color888();


	SetViewport(viewport);

}


public void destruct() {


}


public void OnDraw (DisplayContext displayContext) {

	Draw(displayContext, mRect_left, mRect_top, mRect_width, mRect_height);

}


public void SetColor (Color888 color) {

	if(!mColor.Equals(color))
	{
		mColor.Assign(color);
		Invalidate();
	}

}


public Color888 GetColor() {
 return  mColor; 
}


public void SetOpacity (short opacity) {

	if(mOpacity != opacity)
	{
		mOpacity = opacity;
		Invalidate();
	}

}


public short GetOpacity() {
 return  mOpacity; 
}


public void SetIsAdditiveTransparency (boolean isAdditiveTransparency) {

	if(mIsAdditiveTransparency != isAdditiveTransparency)
	{
		mIsAdditiveTransparency = isAdditiveTransparency;
		Invalidate();
	}

}


public boolean GetIsAdditiveTransparency() {
 return  mIsAdditiveTransparency; 
}


public short GetRed() {
 return  (short)mColor.GetRed(); 
}


public short GetGreen() {
 return  (short)mColor.GetGreen(); 
}


public short GetBlue() {
 return  (short)mColor.GetBlue(); 
}


public void OnSerialize (Package p) {

    super.OnSerialize(p);








 byte opacityByte = 0;

	{
			(opacityByte)= (p).SerializeIntrinsic(opacityByte);
			mOpacity = (short)Memory.MakeUnsignedByte(opacityByte);
			(mIsAdditiveTransparency)= (p).SerializeIntrinsic(mIsAdditiveTransparency);
		}
(mColor).OnSerialize(p);





}


public void ControlValue (int valueCode, boolean setValue, Controller controller) {

	switch(valueCode)
	{
	case brushColor :
		if(setValue)
		{
			SetColor(controller.GetColorValue());
		}
		else
		{
			controller.SetValue(GetColor());
		}
		break;


	case componentOpacity :
		if(setValue)
		{
			SetOpacity((short)controller.GetLongValue());
		}
		else
		{
			controller.SetValue((int)GetOpacity());
		}
		break;
default :
		super.ControlValue(valueCode, setValue, controller);
		break;
	}

}


public void Draw (DisplayContext displayContext, short inRect_left, short inRect_top, short inRect_width, short inRect_height) {


	if(mIsAdditiveTransparency)
	{
		displayContext.DrawRectangle(inRect_left, inRect_top, inRect_width, inRect_height, true, mColor.GetRed(), mColor.GetGreen(), mColor.GetBlue(), (short)(mOpacity | 0x100));
	}
	else
{
		displayContext.DrawRectangle(inRect_left, inRect_top, inRect_width, inRect_height, true, mColor.GetRed(), mColor.GetGreen(), mColor.GetBlue(), mOpacity);
	}


}


public Color888 mColor;
public short mOpacity;
public boolean mIsAdditiveTransparency;

/* One dimension array */
public static Shape[] InstArrayShape(int size) {
	Shape[] newArray = new Shape[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Shape();
	return newArray; }

/* Two dimension array */
public static Shape[][] InstArrayShape(int size1, int size2) {
	Shape[][] newArray = new Shape[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Shape[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Shape(); }
	return newArray; }

/* Three dimension array */
public static Shape[][][] InstArrayShape(int size1, int size2, int size3) {
	Shape[][][] newArray = new Shape[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Shape[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Shape[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Shape(); } }
	return newArray; }



}

