package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class VibrationManager {

public  VibrationManager () {


	

mVibrator = (android.os.Vibrator)FlAndroidApp.instance.getSystemService(FlAndroidApp.instance.VIBRATOR_SERVICE);
	
}


public void destruct() {

	Stop();

}


public static VibrationManager Get () {

	if(FrameworkGlobals.GetInstance().vibrationManager == null)
	{
		FrameworkGlobals.GetInstance().vibrationManager = new VibrationManager();
	}
	return FrameworkGlobals.GetInstance().vibrationManager;


}


public void Start (int miliseconds) {

	miliseconds = miliseconds / SpecConstants.VibrationDivisiveFactor;


	
	

{	
		if(mEnabled)
		{
			





			
			
			
			


mVibrator.vibrate(miliseconds);

			









































vibrationStopTime = Application.GetRealTime() + miliseconds;		
			
		}
	}

}


public void Stop () {


	
	
		mVibrator.cancel();
	
	















}


public void SetEnabled (boolean enabled) {


		
	if(mEnabled != enabled)
	{
		mEnabled = enabled;
		if(!enabled)
		{
			Stop();
		}
	}

}


public boolean IsEnabled () {

	return  mEnabled;	

}


public boolean IsVibrating () {

	if(mEnabled)
	{
		

return  (Application.GetRealTime() <= vibrationStopTime);
		}
	
	return  false;

}


public boolean mEnabled;
public android.os.Vibrator mVibrator;
public int vibrationStopTime;

/* One dimension array */
public static VibrationManager[] InstArrayVibrationManager(int size) {
	VibrationManager[] newArray = new VibrationManager[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new VibrationManager();
	return newArray; }

/* Two dimension array */
public static VibrationManager[][] InstArrayVibrationManager(int size1, int size2) {
	VibrationManager[][] newArray = new VibrationManager[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new VibrationManager[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new VibrationManager(); }
	return newArray; }

/* Three dimension array */
public static VibrationManager[][][] InstArrayVibrationManager(int size1, int size2, int size3) {
	VibrationManager[][][] newArray = new VibrationManager[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new VibrationManager[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new VibrationManager[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new VibrationManager(); } }
	return newArray; }



}

