package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class FileLoader {

public final static short statusInitializing = 0;
public final static short statusLoading = 1;
public final static short statusUnloading = 2;
public final static short statusDone = 3;

public  FileLoader () {
mStatus = (statusInitializing);



}


public void destruct() {

	Terminate();

}


public void Initialize ( String filename, int[] segmentSize, int segmentCount, int version) {













	mFile = new FileHandler();
	mFile.Initialize(filename, segmentSize, segmentCount, version);

}


public void Terminate () {















if(mFile != null)
	{
		mFile.Terminate();
		mFile = null;
	}

}


public FileHandler OnLoad () {



return  OnLoadWithoutBackup();

}


public FileHandler OnLoadWithBackup () {

































































	return  null;

}


public FileHandler OnLoadWithoutBackup () {


	 FileHandler file = mFile;

	if(mStatus == statusInitializing)
	{



		file.StartReadingProcess();
		mStatus = statusLoading;
	}

	if(mStatus == statusLoading)
	{


		 short fileStatus = file.GetStatus();


		if(fileStatus != FileHandler.statusWorking)
		{
			if(fileStatus == FileHandler.statusNotFound)
			{

				file.StartCreationProcess();
				
				
				fileStatus = file.GetStatus();
			}
			
			if(fileStatus != FileHandler.statusNotFound)
			{
				return  TerminateLoading(file);
			}
		}
	}
	else
	{

	}

	return  null;




}


public FileHandler TerminateLoading (FileHandler selectedFile) {

















	mFile = null;
mStatus = statusDone;

	return  selectedFile;

}


public FileHandler SelectFileAndAlternateBackup () {







































	return  null;

}


public short mStatus;
public FileHandler mFile;

/* One dimension array */
public static FileLoader[] InstArrayFileLoader(int size) {
	FileLoader[] newArray = new FileLoader[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new FileLoader();
	return newArray; }

/* Two dimension array */
public static FileLoader[][] InstArrayFileLoader(int size1, int size2) {
	FileLoader[][] newArray = new FileLoader[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FileLoader[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new FileLoader(); }
	return newArray; }

/* Three dimension array */
public static FileLoader[][][] InstArrayFileLoader(int size1, int size2, int size3) {
	FileLoader[][][] newArray = new FileLoader[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FileLoader[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new FileLoader[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new FileLoader(); } }
	return newArray; }



}

