package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class InGameMusicMode {

public final static byte kInGameMusic1 = 0;
public final static byte kInGameMusic2 = 1;
public final static byte kInGameMusicOff = 2;


/* One dimension array */
public static InGameMusicMode[] InstArrayInGameMusicMode(int size) {
	InGameMusicMode[] newArray = new InGameMusicMode[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new InGameMusicMode();
	return newArray; }

/* Two dimension array */
public static InGameMusicMode[][] InstArrayInGameMusicMode(int size1, int size2) {
	InGameMusicMode[][] newArray = new InGameMusicMode[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new InGameMusicMode[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new InGameMusicMode(); }
	return newArray; }

/* Three dimension array */
public static InGameMusicMode[][][] InstArrayInGameMusicMode(int size1, int size2, int size3) {
	InGameMusicMode[][][] newArray = new InGameMusicMode[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new InGameMusicMode[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new InGameMusicMode[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new InGameMusicMode(); } }
	return newArray; }

public InGameMusicMode () { 
}




}

