package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class ResultsScene extends BaseScene {

public  ResultsScene (byte packageID) {
super(packageID);



}


public void destruct() {


}


public boolean IsResultScene() {
 return  true; 
}


public void Init () {



 TetrisState tetrisState = GetTetrisState();
	 TetrisGame gamePlayerOne = GetPlayer1GameState();
















switch(tetrisState.GetGameMode())
	{
		
		
		
		
		case TetrisState.kModeMarathon :
		{
			String[] tResults = {
								new String(gamePlayerOne.GetScore()),
								new String(gamePlayerOne.GetLineCount()),
								new String(gamePlayerOne.GetLevel())
								};

			
			if(tetrisState.IsNewRecord(TetrisState.kStatMarathonScore))
			{
				ShowNewRecordText(RSRC_marathonScoreMenuScenePackage.marathonScoreItem3Text_ID);
			}

			SetSinglePlayerResults(tResults, tResults.length); 
		}
		break;

		case TetrisState.kModeUltra :
		{
			String[] tResults = {
								new String(gamePlayerOne.GetScore()),
								new String(gamePlayerOne.GetLevel())
								};

			if(tetrisState.IsNewRecord(TetrisState.kStatUltraScore))
			{
				ShowNewRecordText(RSRC_ultraScoreMenuScenePackage.ultraScoreItem3Text_ID);
			}

			SetSinglePlayerResults(tResults, tResults.length);

			Scroller scrollerToReset = null;

			(scrollerToReset)= (scrollerToReset).Cast((mpPackage).GetEntryPoint(RSRC_ultraScoreMenuScenePackage.ultraScoreSceneScroller_ID), null);
			scrollerToReset.ResetScroller();
		}
		break;

		case TetrisState.kMode40Lines :
		{
			 TetrisGame tetrisGame = GetPlayer1GameState();

			if(!tetrisGame.IsWon40Lines())
			{
				Text SuccessText = null;

				String failedMsgString = null;


				(SuccessText)= (SuccessText).Cast((mpPackage).GetEntryPoint(RSRC_fortyLinesScoreMenuScenePackage.fortyLinesScoreItemSuccessText_ID), null);
				(failedMsgString)= (failedMsgString).Cast((mpPackage).GetEntryPoint(RSRC_fortyLinesScoreMenuScenePackage.statisticsFailedString_ID), null);

				SuccessText.SetCaption(failedMsgString);



}
			 String formattedTime = new String(StringToolbox.FormatTime(gamePlayerOne.GetPlayTimeMs()));

			String[] tResults = {new String(formattedTime)};

			if(tetrisState.IsNewRecord(TetrisState.kStat40LinesTime)) 
			{
				ShowNewRecordText(RSRC_fortyLinesScoreMenuScenePackage.fortyLinesScoreItem3Text_ID);
			}


			SetSinglePlayerResults(tResults, tResults.length);

			Scroller scrollerToReset = null;

			(scrollerToReset)= (scrollerToReset).Cast((mpPackage).GetEntryPoint(RSRC_fortyLinesScoreMenuScenePackage.fortyLinesScoreSceneScroller_ID), null);
			scrollerToReset.ResetScroller();
		}
		break;

		
		
		































default : ;
	}


















{
		
		UpdateSoftKey(declineSoftKey, null, (((int)ConstantsEnglishPortrait.noneCommand == (int)ConstantsEnglishLandscape.noneCommand) ? Constants.noneCommand : ConstantsGetter.GetConstants().noneCommandFct()));
	}

	super.Init();

}


public void ShowNewRecordText (int entryPointID) {

	 Text newNewRecordText = null;
	(newNewRecordText)= (newNewRecordText).Cast((mpPackage).GetEntryPoint(entryPointID), null);
	newNewRecordText.SetVisible(true);

}


public void SetSinglePlayerResults (String tResults[] , int numberOfElement) {

	 Text resultsDataText = null;
	for(int i = 0;i < numberOfElement;i ++)
	{
		(resultsDataText)= (resultsDataText).Cast((mpPackage).GetEntryPoint(RSRC_marathonScoreMenuScenePackage.marathonScoreItem2Text_ID + i), null);
		resultsDataText.SetCaption(tResults[i]);
	}

}





}

