package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class ScreenManager extends SimPCScreenManager {

public static ScreenManager Get () {

	return  GetApp().GetScreenManager();

}


public ScreenManager () {

	Init();

}



/* One dimension array */
public static ScreenManager[] InstArrayScreenManager(int size) {
	ScreenManager[] newArray = new ScreenManager[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new ScreenManager();
	return newArray; }

/* Two dimension array */
public static ScreenManager[][] InstArrayScreenManager(int size1, int size2) {
	ScreenManager[][] newArray = new ScreenManager[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new ScreenManager[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new ScreenManager(); }
	return newArray; }

/* Three dimension array */
public static ScreenManager[][][] InstArrayScreenManager(int size1, int size2, int size3) {
	ScreenManager[][][] newArray = new ScreenManager[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new ScreenManager[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new ScreenManager[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new ScreenManager(); } }
	return newArray; }



}

