package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Color888 {

public static Color888 Cast(Object o, Color888 _) {
 return  (Color888)o; 
}


 final public static byte typeNumber = TypeIDOfType_Color888.v;
 final public static byte typeID = TypeIDOfType_Color888.w;
 public static final boolean supportsDynamicSerialization = false; public Color888 () {




}


public Color888 (int parR, int parG, int parB) {

	rgb[0] = (short)parR;
	rgb[1] = (short)parG;
    rgb[2] = (short)parB;

}


public Color888 ( Color888 other) {


	rgb[0] = other.rgb[0];
	rgb[1] = other.rgb[1];
	rgb[2] = other.rgb[2];





}


public void OnSerialize (Package p) {



	byte b;

	b = (byte)rgb[0]; (b)= (p).SerializeIntrinsic(b); rgb[0] = (short)Memory.MakeUnsignedByte(b);
	b = (byte)rgb[1]; (b)= (p).SerializeIntrinsic(b); rgb[1] = (short)Memory.MakeUnsignedByte(b);
	b = (byte)rgb[2]; (b)= (p).SerializeIntrinsic(b); rgb[2] = (short)Memory.MakeUnsignedByte(b);








}


public int GetRed() {
 return  rgb[0]; 
}


public int GetGreen() {
 return  rgb[1]; 
}


public int GetBlue() {
 return  rgb[2]; 
}


public void SetRed(int red) {
 rgb[0] = (short)red; 
}


public void SetGreen(int green) {
 rgb[1] = (short)green; 
}


public void SetBlue(int blue) {
 rgb[2] = (short)blue; 
}


public Color888 Darker () {

	return  new Color888(GetRed() / 2, GetGreen() / 2, GetBlue() / 2);

}


public Color888 Lighter () {

	return  new Color888(255- (255- GetRed()) / 2, 255- (255- GetGreen()) / 2, 255- (255- GetBlue()) / 2);

}


public int ToRGB888 () {


	return   ((int)rgb[0] << 16) | ((int)rgb[1] << 8) | ((int)rgb[2]);



}


public Color888 ToColor888 () {

	return this;

}


public boolean Equals ( Color888 RHS) {


	return  (rgb[0] == RHS.rgb[0]) && (rgb[1] == RHS.rgb[1]) && (rgb[2] == RHS.rgb[2]);



}


public  Color888 Assign ( Color888 color) {


	rgb[0] = color.rgb[0];
	rgb[1] = color.rgb[1];
	rgb[2] = color.rgb[2];
	return this;






}


public static Color888 Color888From565 (short color565) {


	 short r = (short)(((color565 & 0xF800) >> 8) | 0x07);
 
	 short g = (short)(((color565 & 0x07E0) >> 3) | 0x03);

	 short b = (short)(((color565 & 0x001F) << 3) | 0x07);

	return   new Color888(r, g, b);






}


public short[] rgb = new short[3];


/* One dimension array */
public static Color888[] InstArrayColor888(int size) {
	Color888[] newArray = new Color888[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Color888();
	return newArray; }

/* Two dimension array */
public static Color888[][] InstArrayColor888(int size1, int size2) {
	Color888[][] newArray = new Color888[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Color888[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Color888(); }
	return newArray; }

/* Three dimension array */
public static Color888[][][] InstArrayColor888(int size1, int size2, int size3) {
	Color888[][][] newArray = new Color888[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Color888[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Color888[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Color888(); } }
	return newArray; }



}

