package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class SpecConstants {

public final static int AlphaLevel = 256;
public final static int BrewMixerDeviceBitRate = 22050;
public final static int BrewMixerStartDelayTime = 0;
public final static int BytesByPixel = 2;
public final static int BytesByPixelMutable = 0;
public final static int BytesByPixelPalettized = 0;
public final static int CanvasHeight = 0;
public final static int CanvasWidth = 0;
public final static int FlightKeyCodeFire = 9999;
public final static int FlightKeyCodeLeftSoftkey = 99998;
public final static int FlightKeyCodeRightSoftkey = 99999;
public final static int FlightTargetID = 1000000;
public final static int ForcePeriodicInvalidateTime = 0;
public final static int FreeHeapAfterMaxImage = 0;
public final static int FullScreenHeight = 455;
public final static int FullScreenWidth = 320;
public final static int HadesDeviceID = 0;
public final static int HardwareManagerOperatorID = 9999;
public final static int HardwareManagerPlatformID = 3;
public final static int HdMgrID = 0;
public final static int Heap = 8700000;
public final static int IdleOnTimeoutTime = -1;
public final static int InactivityTimeoutMs = 60000;
public final static int InvalidTimeIntervalHigherBound = 0;
public final static int InvalidTimeIntervalLowerBound = 0;
public final static int JBenchmark12DShapesScore = 0;
public final static int JBenchmark13DShapesScore = 0;
public final static int JBenchmark1AnimationScore = 0;
public final static int JBenchmark1FillRateScore = 0;
public final static int JBenchmark1FreeMemory = 0;
public final static int JBenchmark1Rating = 0;
public final static int JBenchmark1TextScore = 0;
public final static int JBenchmark1TotalMemory = 0;
public final static int JBenchmark3DRatingHigh = 0;
public final static int JBenchmark3DRatingLow = 0;
public final static int KeyCodeAccept = 99998;
public final static int KeyCodeAlt = 99998;
public final static int KeyCodeBack = 99999;
public final static int KeyCodeBackspace = 99999;
public final static int KeyCodeCaps = 99999;
public final static int KeyCodeClamshell1 = 99999;
public final static int KeyCodeClamshell2 = 99999;
public final static int KeyCodeClamshell3 = 99999;
public final static int KeyCodeDecline = 99999;
public final static int KeyCodeDown = 6;
public final static int KeyCodeEnd = 99999;
public final static int KeyCodeEnter = 99999;
public final static int KeyCodeFire = 9999;
public final static int KeyCodeLeft = 2;
public final static int KeyCodeLeftSoftkey = 99998;
public final static int KeyCodeMediaPlayer = 99999;
public final static int KeyCodeMenu = 99999;
public final static int KeyCodePound = 35;
public final static int KeyCodeRight = 5;
public final static int KeyCodeRightSoftkey = 99999;
public final static int KeyCodeSend = 99999;
public final static int KeyCodeShift = 99999;
public final static int KeyCodeSpace = 32;
public final static int KeyCodeStar = 42;
public final static int KeyCodeUnused1 = 99999;
public final static int KeyCodeUp = 1;
public final static int KeyCodeVolumeDown = 99999;
public final static int KeyCodeVolumeUp = 99999;
public final static int KeyCodeWheelClick = 99999;
public final static int KeyCodeWheelDown = 99999;
public final static int KeyCodeWheelUp = 99999;
public final static int KtexelsPerSecond = 0;
public final static int LargeSysFont = 0;
public final static int MasterVolumeScaleFactor = 0;
public final static int MaxAllocatedHeap = 0;
public final static int MaxAllocatedHeapAfterImage = 0;
public final static int MaxGameSize = 1572864;
public final static int MaxImageSizeXxXFullyUsedMemory = 0;
public final static int MaxImageSizeXxXWithFreeMemory = 0;
public final static int MaxLights = 0;
public final static int MaxNbImageSizeXxX = 0;
public final static int MaxPrefetchedSoundsLongAmr = 0;
public final static int MaxPrefetchedSoundsLongMid = 0;
public final static int MaxPrefetchedSoundsLongQcp = 0;
public final static int MaxPrefetchedSoundsLongWav = 0;
public final static int MaxPrefetchedSoundsShortAmr = 0;
public final static int MaxPrefetchedSoundsShortMid = 0;
public final static int MaxPrefetchedSoundsShortQcp = 0;
public final static int MaxPrefetchedSoundsShortWav = 0;
public final static int MaxSpriteCropDimension = 0;
public final static int MaxTextureDimension = 0;
public final static int MaxTransformsPerVertex = 0;
public final static int MaxViewportDimension = 0;
public final static int MediumSysFont = 0;
public final static int MemUsedMutableImg128x128 = 0;
public final static int MemUsedMutableImg64x64 = 0;
public final static int MemUsedPalettizedImg128x128 = 0;
public final static int MemUsedPalettizedImg64x64 = 0;
public final static int MixerBufferSize = 2048;
public final static int NbTouchDetected = 1;
public final static int NetworkTimeOutLimit = 25000;
public final static int NumberOfTextureUnits = 0;
public final static int NumberOfThreads = 0;
public final static int PlatformID = 0;
public final static int PrefetchedSoundTimeLongAmr = 0;
public final static int PrefetchedSoundTimeLongMid = 0;
public final static int PrefetchedSoundTimeLongQcp = 0;
public final static int PrefetchedSoundTimeLongWav = 0;
public final static int PrefetchedSoundTimeShortAmr = 0;
public final static int PrefetchedSoundTimeShortMid = 0;
public final static int PrefetchedSoundTimeShortQcp = 0;
public final static int PrefetchedSoundTimeShortWav = 0;
public final static int RSMaxCount = 0;
public final static int RunTimePngArraySize = 0;
public final static int SmallSysFont = 0;
public final static int SprintAPIPlaySoundDefectiveDurationAfterInterrupt = 0;
public final static int StartedSoundTimeLongAmr = 0;
public final static int StartedSoundTimeLongMid = 0;
public final static int StartedSoundTimeLongQcp = 0;
public final static int StartedSoundTimeLongWav = 0;
public final static int StartedSoundTimeShortAmr = 0;
public final static int StartedSoundTimeShortMid = 0;
public final static int StartedSoundTimeShortQcp = 0;
public final static int StartedSoundTimeShortWav = 0;
public final static int StatusBarHeight = 0;
public final static int SystemVSRealTimeRatio = 100;
public final static int TimeToWaitBeforePlayingAnotherVibration = 0;
public final static int TimeToWaitBeforeStopSound = 0;
public final static int TrianglesPerSecond = 0;
public final static int UpperBarInGameHeight = 0;
public final static int UsableHeap = 8700000;
public final static int UsedHeight = 455;
public final static int UsedWidth = 320;
public final static int VibrationDivisiveFactor = 1;
public final static int VibrationHardwareId = 0;
public final static int VideoMemory = 0;
public final static int YieldDefectiveMainLoopSleepDuration = 10;


/* One dimension array */
public static SpecConstants[] InstArraySpecConstants(int size) {
	SpecConstants[] newArray = new SpecConstants[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new SpecConstants();
	return newArray; }

/* Two dimension array */
public static SpecConstants[][] InstArraySpecConstants(int size1, int size2) {
	SpecConstants[][] newArray = new SpecConstants[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new SpecConstants[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new SpecConstants(); }
	return newArray; }

/* Three dimension array */
public static SpecConstants[][][] InstArraySpecConstants(int size1, int size2, int size3) {
	SpecConstants[][][] newArray = new SpecConstants[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new SpecConstants[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new SpecConstants[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new SpecConstants(); } }
	return newArray; }

public SpecConstants () { 
}




}

