package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class VideoMode {

public final static byte videoModeWidth = 0;
public final static byte videoModeHeight = 1;
public final static byte videoModeBpp = 2;
public final static byte videoModeDataCount = 3;

public VideoMode () {




}


public VideoMode ( VideoMode other) {



mData[videoModeWidth] = other.GetWidth();
	mData[videoModeHeight] = other.GetHeight();
	mData[videoModeBpp] = other.GetBpp();

}


public VideoMode (int w, int h, int b) {



mData[videoModeWidth] = w;
	mData[videoModeHeight] = h;
	mData[videoModeBpp] = b;

}


public int GetWidth() {
 return  mData[videoModeWidth]; 
}


public int GetHeight() {
 return  mData[videoModeHeight]; 
}


public int GetBpp () {
 
	return  mData[videoModeBpp]; 

}


public void SetWidth(int w) {
 mData[videoModeWidth] = w; 
}


public void SetHeight(int h) {
 mData[videoModeHeight] = h; 
}


public void SetBpp ( int b) {
 


mData[videoModeBpp] = b; 

}


public int GetBytesPerPixel() {
 return  ((mData[videoModeBpp] - 1) >> 3) + 1; 
}


public int[] mData = new int[videoModeDataCount];


/* One dimension array */
public static VideoMode[] InstArrayVideoMode(int size) {
	VideoMode[] newArray = new VideoMode[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new VideoMode();
	return newArray; }

/* Two dimension array */
public static VideoMode[][] InstArrayVideoMode(int size1, int size2) {
	VideoMode[][] newArray = new VideoMode[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new VideoMode[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new VideoMode(); }
	return newArray; }

/* Three dimension array */
public static VideoMode[][][] InstArrayVideoMode(int size1, int size2, int size3) {
	VideoMode[][][] newArray = new VideoMode[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new VideoMode[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new VideoMode[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new VideoMode(); } }
	return newArray; }



}

