package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class GameScene extends BaseScene {

public final static int WORST_FRAME_COUNT = 3;
public final static int FPS_FRAME_SAMPLE_COUNT = 20;

public  GameScene (byte packageID) {
super(packageID);
mDisplayGhost = (true);
mLastGameTimeUpdate = (-1000);
mGameSceneCurrentAnim = (GameScene.kNone);
mGameSceneState = (kWaitingOnResources);


	

	int i;


	for(i = 0;i < TetrisState.kPlayerCount;i ++)
	{







mDangerStateEnable[i] = false;
}









































}


public void destruct() {




}


public void Suspend () {

	

	if(!GetApp().IsInTransition())
	{




















{

			HandleCommand((((int)ConstantsEnglishPortrait.goToPauseSceneCommand == (int)ConstantsEnglishLandscape.goToPauseSceneCommand) ? Constants.goToPauseSceneCommand : ConstantsGetter.GetConstants().goToPauseSceneCommandFct()));
}
	}
	else
	{
		super.Suspend();
	}

}


public void Resume () {

	

	if(!GetApp().IsInTransition())
	{














}
	else
	{
		super.Resume();
	}

}


public void GetResources () {

	


	 TetrisApp tetrisApp = GetApp();

	
	tetrisApp.UnloadMenuDependencies();

	super.GetResources();


	
	TetrisApp.GetInstance().SetMultiKeyPress();
	
 KeyFrameController pBorderController = null;
	 Component pReplacedComponent = null;

	for(int animatedBorderIndex = 0;animatedBorderIndex < (((int)ConstantsEnglishPortrait.borderWindowsComponentCount == (int)ConstantsEnglishLandscape.borderWindowsComponentCount) ? Constants.borderWindowsComponentCount : ConstantsGetter.GetConstants().borderWindowsComponentCountFct());animatedBorderIndex ++ )
	{
		(pBorderController)= (pBorderController).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameSceneMatrixBorderFirstLeftBarController_ID + animatedBorderIndex), null);
		(pReplacedComponent)= (pReplacedComponent).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.matrixFirstLeftBorderHighLightComponent_ID + animatedBorderIndex), null);

		mpMatrixBorderWindowViewport[animatedBorderIndex] = new WindowViewport();
		mpMatrixBorderWindowViewport[animatedBorderIndex].SetSize(pReplacedComponent.GetRectWidth(), pReplacedComponent.GetRectHeight());
		TetrisApp.ReplaceComponent(pReplacedComponent, mpMatrixBorderWindowViewport[animatedBorderIndex]);

		pReplacedComponent.SetViewport(mpMatrixBorderWindowViewport[animatedBorderIndex]);
		pBorderController.SetControlParameters(mpMatrixBorderWindowViewport[animatedBorderIndex], (((int)ConstantsEnglishPortrait.windowViewportRect == (int)ConstantsEnglishLandscape.windowViewportRect) ? Constants.windowViewportRect : ConstantsGetter.GetConstants().windowViewportRectFct()));
	}

	for(int i = 0;i < (((int)ConstantsEnglishPortrait.matrixBorderSubTimeSystemCount == (int)ConstantsEnglishLandscape.matrixBorderSubTimeSystemCount) ? Constants.matrixBorderSubTimeSystemCount : ConstantsGetter.GetConstants().matrixBorderSubTimeSystemCountFct());i ++)
	{
		(mpMatrixBorderTimeSystem)= (mpMatrixBorderTimeSystem).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameSceneMatrixBorderAnimationSecondTimeSystem_ID + i), null);
		mpMatrixBorderTimeSystem.SetTotalTime((i + 1) * (((int)ConstantsEnglishPortrait.borderInitPeriodStep == (int)ConstantsEnglishLandscape.borderInitPeriodStep) ? Constants.borderInitPeriodStep : ConstantsGetter.GetConstants().borderInitPeriodStepFct()));
	}

	mpMatrixBorderTimeSystem = TetrisApp.GetAndRegisterAndStopTimeSystem(mpPackage, RSRC_gameScenePackage.gameSceneMatrixBorderAnimationTimeSystem_ID);
	mpMatrixBorderTimeSystem.Start();
 Viewport pPlayerMatrixViewport = null;

	(pPlayerMatrixViewport)= (pPlayerMatrixViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameSceneMatrixViewport_ID), null);



(mpLevelNumberText)= (mpLevelNumberText).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameSceneLevelNumberText_ID), null);

	(mpGameStatusText)= (mpGameStatusText).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameSceneGameStatusText_ID), null);
	mpGameStatusFlashTimeSystem = TetrisApp.GetAndRegisterAndStopTimeSystem(mpPackage, RSRC_gameScenePackage.gameSceneStatusFlashTimeSystem_ID);
	mpGameStatusText.SetVisible(false);

	(mpLinesNumberText)= (mpLinesNumberText).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameSceneHudL2NumberText_ID), null);

	
	for(int str = 0;str < kGameStringsCount;str ++)
	{
		
		(mpGameStrings[str])= (mpGameStrings[str]).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameOverStr_ID + str), null);
	}


	mpSpecialStatusTimeSystem = TetrisApp.GetAndRegisterAndStopTimeSystem(mpPackage, RSRC_gameScenePackage.gameSceneSpecialStatusTimeSystem_ID);



	(mpSpecialStatusSizeTimeSystem)= (mpSpecialStatusSizeTimeSystem).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.statusTextOneLineTimeSystem_ID), null);

	
	 Viewport pReplacedViewport = null;
	(pReplacedViewport)= (pReplacedViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameSceneSpecialStatusViewport_ID), null);

	mpStatusTextHighAnimationWindowViewport = new WindowViewport();
	mpStatusTextHighAnimationWindowViewport.SetSize(pReplacedViewport.GetRectWidth(), pReplacedViewport.GetRectHeight());

	TetrisApp.ReplaceComponent(pReplacedViewport, mpStatusTextHighAnimationWindowViewport);
	pReplacedViewport.SetViewport(mpStatusTextHighAnimationWindowViewport);

	 KeyFrameController pStatusTextRectController = null;

	for(int controllerIndex = 0;controllerIndex < (((int)ConstantsEnglishPortrait.statusTextHighAnimationControllerCount == (int)ConstantsEnglishLandscape.statusTextHighAnimationControllerCount) ? Constants.statusTextHighAnimationControllerCount : ConstantsGetter.GetConstants().statusTextHighAnimationControllerCountFct());controllerIndex ++)
	{
		(pStatusTextRectController)= (pStatusTextRectController).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.statusTextSizeOneLineController_ID + controllerIndex), null);
		pStatusTextRectController.SetControlParameters(mpStatusTextHighAnimationWindowViewport, (((int)ConstantsEnglishPortrait.windowViewportRect == (int)ConstantsEnglishLandscape.windowViewportRect) ? Constants.windowViewportRect : ConstantsGetter.GetConstants().windowViewportRectFct()));
	}
	
 int nbHud = 0;
















































































{
		
		if(GetTetrisState().IsNeededToShowScore())
		{







{
				mpScoreNumberText = InitHud(nbHud, RSRC_gameScenePackage.scoreStr_ID);
				nbHud++;
			}
		}
		
		if(GetTetrisState().IsNeededToShowTime())
		{
			mpTimeNumberText = InitHud(nbHud, RSRC_gameScenePackage.timeStr_ID);
			UpdateTimeHUD();
			nbHud++;
		}








if(GetTetrisState().IsNeededToShowLine())
		{
			mpLinesNumberText = InitHud(nbHud, RSRC_gameScenePackage.lineStr_ID);
			nbHud++;
			
			if(GetTetrisState().IsModeMarathon())
			{

				mpGoalNumberText = InitHud(nbHud, RSRC_gameScenePackage.goalStr_ID);
				nbHud++;





}
		}
	}

	 Viewport pHud = null;

	for(int hudIndex = 0;hudIndex < nbHud;hudIndex ++)
	{
		






(pHud)= (pHud).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameSceneHudL1Viewport_ID + hudIndex), null);
		pHud.SetVisible(true);














}











































 Package playerMinoPackage = null;

	playerMinoPackage = RessourcesManager.Get().GetPackage(PackageID.darkMino);


mpWellComponents[TetrisState.kPlayer1] = new WellComponent(GetPlayer1GameState().GetWell(), playerMinoPackage, true);
	mpWellComponents[TetrisState.kPlayer1].SetViewport(pPlayerMatrixViewport);


	
	(mpGameOverFillMatrixTimeSystem)= (mpGameOverFillMatrixTimeSystem).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameSceneGameOverMatrixFillTimeSystem_ID), null);

	playerMinoPackage = RessourcesManager.Get().GetPackage(PackageID.playerMino);
(mpHardDropReboundTimeSystem)= (mpHardDropReboundTimeSystem).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameSceneHardDropReboundTimeSystem_ID), null);
	(mpHardDropReboundController)= (mpHardDropReboundController).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameSceneHardDropReboundController_ID), null);
	mpBouncingPiece = new Piece(playerMinoPackage, Piece.kPieceRebound);
	mpBouncingPiece.SetViewport(pPlayerMatrixViewport);
	mpHardDropReboundController.SetControlParameters(mpBouncingPiece, componentPosition);
if(GetTetrisState().IsMultiplayerMode())
	{







}













mpGhostPiece = new Piece(playerMinoPackage, Piece.kPieceGhost);
	mpGhostPiece.SetViewport(pPlayerMatrixViewport);

	
	mpFallingPiece = new Piece(playerMinoPackage, Piece.kPieceFalling);
	mpFallingPiece.SetViewport(pPlayerMatrixViewport);

	 Tetrimino fallingTetrimino = GetMainMatrixPlayerGameState().GetFallingTetrimino();
	 boolean showFallingTetrimino = fallingTetrimino != null && !fallingTetrimino.IsLock();


	if(showFallingTetrimino)
	{
		mpFallingPiece.SetTetrimino(fallingTetrimino);
		mpFallingPiece.UpdatePosition();
	}

	mDisplayGhost = GetApp().GetOptionSettings().IsGhostEnabled();
	boolean mustShowGhostPiece;

	mustShowGhostPiece = mDisplayGhost && showFallingTetrimino;

	if(mustShowGhostPiece)
	{
		mpGhostPiece.SetTetrimino(GetTetrisState().GetPlayer(GetMainMatrixPlayer()).GetGhostTetrimino(), true);
		mpGhostPiece.UpdatePosition();
	}
	else
	{
		mpGhostPiece.SetVisible(false);
	}


	
	 Viewport pPieceHoldViewport = null;
	(pPieceHoldViewport)= (pPieceHoldViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameScenePieceHoldViewport_ID), null);
	mpHoldedPiece = new Piece(playerMinoPackage);
	mpHoldedPiece.SetViewport(pPieceHoldViewport);
	 Tetrimino holdedTetrimino = GetMainMatrixPlayerGameState().GetHoldedTetrimino();
	if(holdedTetrimino == null)
	{
		mpHoldedPiece.SetVisible(false);
	}
	else
	{
		mpHoldedPiece.SetTetrimino(holdedTetrimino);
	}


	
	TimeSystem pHighlightAnimTimeSystem = null;

	(pHighlightAnimTimeSystem)= (pHighlightAnimTimeSystem).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.pieceHighlightTimeSystem_ID), null);

	 Package highlightMinoPackage = RessourcesManager.Get().GetPackage(PackageID.highlightMino);
	mpHighlightPiece = new Piece(highlightMinoPackage, Piece.kPieceHighlight, pHighlightAnimTimeSystem);

	mpHighlightPieceWindow = new WindowViewport();
	mpHighlightPieceWindow.SetViewport(pPlayerMatrixViewport);
	mpHighlightPiece.SetViewport(mpHighlightPieceWindow);

	
	Controller pHighlightController = null;

	(pHighlightController)= (pHighlightController).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.pieceHighlightKeyFrameController_ID), null);
	pHighlightController.SetControlParameters(mpHighlightPieceWindow, (((int)ConstantsEnglishPortrait.windowViewportRect == (int)ConstantsEnglishLandscape.windowViewportRect) ? Constants.windowViewportRect : ConstantsGetter.GetConstants().windowViewportRectFct()));
mpNextQueueAnimationTimeSystem = TetrisApp.GetAndRegisterAndStopTimeSystem(mpPackage, RSRC_gameScenePackage.gameSceneNextQueueTimeSystem_ID);
 int visualQueueCount = GetVisualQueueCount();




{
		int i;

		for(i = 0;i < kHudCircleCount;i ++)
		{

			mpNextQueueRotationTimeSystems[i] = TetrisApp.GetAndRegisterAndStopTimeSystem(mpPackage, RSRC_gameScenePackage.gameScenePieceQueueCircleRotationTimeSystem_ID + i);
(mpCircleIntensityViewport[i])= (mpCircleIntensityViewport[i]).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.pieceQueueCircleHighIntensityComponentsViewport_ID + i), null);
}
	}

	 Viewport pPieceQueueViewport = null;

	for(int queue = 0;queue < visualQueueCount;queue ++)
	{
		
		(pPieceQueueViewport)= (pPieceQueueViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameScenePieceQueueViewport_ID + queue), null);

		for(int i = 0;i < (((int)ConstantsEnglishPortrait.visualPieceQueueSize == (int)ConstantsEnglishLandscape.visualPieceQueueSize) ? Constants.visualPieceQueueSize : ConstantsGetter.GetConstants().visualPieceQueueSizeFct());i ++)
		{

			mpNextPieceQueue[queue][i] = new Piece(playerMinoPackage, (int)(Piece.kIsometricV0 + i));


mpNextPieceQueue[queue][i].SetViewport(pPieceQueueViewport);

			mpNextPieceQueue[queue][i].SetTopLeft((short) 0, i <= 1? (short)(i * (((int)ConstantsEnglishPortrait.nextQueueFirstPiecePosition == (int)ConstantsEnglishLandscape.nextQueueFirstPiecePosition) ? Constants.nextQueueFirstPiecePosition : ConstantsGetter.GetConstants().nextQueueFirstPiecePositionFct()))
																	 : (short) ((((int)ConstantsEnglishPortrait.nextQueueFirstPiecePosition == (int)ConstantsEnglishLandscape.nextQueueFirstPiecePosition) ? Constants.nextQueueFirstPiecePosition : ConstantsGetter.GetConstants().nextQueueFirstPiecePositionFct()) + (i - 1) * (((int)ConstantsEnglishPortrait.nextQueueNextPieceOffset == (int)ConstantsEnglishLandscape.nextQueueNextPieceOffset) ? Constants.nextQueueNextPieceOffset : ConstantsGetter.GetConstants().nextQueueNextPieceOffsetFct())));








}



{
			UpdateVisualQueue((byte)queue);
		}















}















mpCircleIntensityViewport[TetrisState.kPlayer1].SetVisible(mpNextPieceQueue[TetrisState.kPlayer1][0].GetTetrimino() != null);

	
	mpCircleIntensityViewport[kHudCircleHoldSide].SetVisible(mpHoldedPiece.GetTetrimino() != null);
(mpMainPieceQueueViewport)= (mpMainPieceQueueViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameScenePieceQueueViewport_ID), null);





(mpLevelUpTimeSystem)= (mpLevelUpTimeSystem).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameSceneLevelUpTimeSystem_ID), null);
BitmapMap pHardDropParticleBitmapMap = null;

	(pHardDropParticleBitmapMap)= (pHardDropParticleBitmapMap).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.hardDropParticlesFBitmapMap_ID), null);
	mpParticleGenerator = new ParticleGenerator((short)(mpWellComponents[TetrisState.kPlayer1].GetAbsoluteLeft() + (((int)ConstantsEnglishPortrait.playerMatrixMarginSize == (int)ConstantsEnglishLandscape.playerMatrixMarginSize) ? Constants.playerMatrixMarginSize : ConstantsGetter.GetConstants().playerMatrixMarginSizeFct())), mpWellComponents[TetrisState.kPlayer1].GetAbsoluteTop(), (short)mpWellComponents[TetrisState.kPlayer1].GetMinoSize(), pHardDropParticleBitmapMap);

	
	mpParticleGenerator.LoadLineClearParticlesBitmapMaps(mpPackage);

	
	
	mpParticleGenerator.SetViewport(this);
UpdatePieceLockHUD();

	UpdateLevelHUD();
	






























{
		UpdateDangerState(TetrisState.kPlayer1);
	}







}


public void Init () {

	

	super.Init();

	UpdateSoftKey(acceptSoftKey, null, (((int)ConstantsEnglishPortrait.noneCommand == (int)ConstantsEnglishLandscape.noneCommand) ? Constants.noneCommand : ConstantsGetter.GetConstants().noneCommandFct()));

	 TetrisApp tetrisApp = GetApp();









tetrisApp.GetPlayer().InitializeInGameMusic();
		tetrisApp.GetPlayer().PlaySong(TetrisMediaPlayer.kSndInGameMusic);
if(GetTetrisState().MustSyncGameStart())
	{
		mpGameStatusText.SetCaption(new String(mpGameStrings[kWaitForPlayerStr]));
		mpGameStatusText.SetVisible(true);
	}


























mpWellComponents[TetrisState.kPlayer1].SetClearLineAnimDisabled(IsAboveNoAnimLevel());
tetrisApp.SetInputControlerEnabled(true);












}


public void UnloadResources () {

	
	 TetrisApp tetrisApp = GetApp();




tetrisApp.SetInputControlerEnabled(false);






	
	tetrisApp.SetSingleKeyPress();
if(mpWellComponents[TetrisState.kPlayer1] != null)
	{

mpGameOverFillMatrixTimeSystem.UnRegisterInGlobalTime();



mpHighlightPiece.Term();  
mpWellComponents[TetrisState.kPlayer1].SetViewport(null);
		mpWellComponents[TetrisState.kPlayer1].Term();
		mpWellComponents[TetrisState.kPlayer1] = null;









mpFallingPiece.SetViewport(null);
		mpFallingPiece = null;


mpHoldedPiece.SetViewport(null);
		mpHoldedPiece = null;


mpGhostPiece.SetViewport(null);
		mpGhostPiece = null;



mpHighlightPieceWindow.SetViewport(null);
		mpHighlightPieceWindow = null;
 int visualQueueCount = GetVisualQueueCount();


		for(int queue = 0;queue < visualQueueCount;queue ++)
		{
			for(int i = 0;i < (((int)ConstantsEnglishPortrait.visualPieceQueueSize == (int)ConstantsEnglishLandscape.visualPieceQueueSize) ? Constants.visualPieceQueueSize : ConstantsGetter.GetConstants().visualPieceQueueSizeFct());i ++)
			{

mpNextPieceQueue[queue][i].SetViewport(null);
				mpNextPieceQueue[queue][i] = null;
			}
		}

		mpGameStatusFlashTimeSystem.UnRegisterInGlobalTime();

		





mpLevelUpTimeSystem.UnRegisterInGlobalTime();
mpSpecialStatusTimeSystem.UnRegisterInGlobalTime();


		mpSpecialStatusSizeTimeSystem.UnRegisterInGlobalTime();

		TetrisApp.ReplaceComponent(mpStatusTextHighAnimationWindowViewport, mpStatusTextHighAnimationWindowViewport.GetChild(0));
		mpStatusTextHighAnimationWindowViewport = null;
mpParticleGenerator.StopLineClearParticles();
		mpParticleGenerator.StopHardDropParticles();
mpNextQueueAnimationTimeSystem.UnRegisterInGlobalTime();
{
			int i;

			for(i = 0;i < kHudCircleCount;i ++)
			{
				mpNextQueueRotationTimeSystems[i].UnRegisterInGlobalTime();


}
		}
{
			int i;

			for(i = 0;i < (((int)ConstantsEnglishPortrait.borderWindowsComponentCount == (int)ConstantsEnglishLandscape.borderWindowsComponentCount) ? Constants.borderWindowsComponentCount : ConstantsGetter.GetConstants().borderWindowsComponentCountFct());i ++)
			{
				
				TetrisApp.ReplaceComponent(mpMatrixBorderWindowViewport[i], mpMatrixBorderWindowViewport[i].GetChild(0));
				mpMatrixBorderWindowViewport[i] = null;
			}
		}

		mpMatrixBorderTimeSystem.UnRegisterInGlobalTime();
mpHardDropReboundTimeSystem.UnRegisterInGlobalTime();
		mpBouncingPiece.SetViewport(null);
		mpBouncingPiece = null;
}









super.UnloadResources();

}


public int GetReloadSceneCommand () {

	return  (((int)ConstantsEnglishPortrait.artificialInterruptionCommand == (int)ConstantsEnglishLandscape.artificialInterruptionCommand) ? Constants.artificialInterruptionCommand : ConstantsGetter.GetConstants().artificialInterruptionCommandFct());

}


public void PrepareExitScene (int command) {

	GetApp().AskClearStackToMainMenuAtNextSceneTransition();

	GetApp().GetPlayer().StopInGameMusic();
super.PrepareExitScene(command);

}


public void OnTime (int totalTimeMs, int deltaTimeMs) {

	

	if(mState < kWaitingOneOnTime || mState >= kExitAnimation)
	{
		super.OnTime(totalTimeMs, deltaTimeMs);
		return ;
	}



NextAnimationState();











if(mGameSceneDelayMs >= 0)
	{
		mGameSceneDelayMs -= deltaTimeMs;
	}

	 boolean ready = false;


	
	if(mGameSceneDelayMs <= 0)
	{
		 byte nextGameState = NextGameSceneState();


		if(nextGameState == kIsGameOver)
		{
			return ;
		}

		ready = (nextGameState == kIsReady);
	}

	if(ready)
	{
		UpdateGameState(deltaTimeMs);
	}

	UpdateWellPhases(deltaTimeMs, ready);


	if(ready)
	{
		UpdateGameUI(deltaTimeMs);
	}

	super.OnTime(totalTimeMs, deltaTimeMs);







}


public boolean OnKey (int key, boolean up) {

	



if(mGameSceneState == kReady)
	{
		if(up)
		{
			return  OnKeyUp(key);
		}
		else
		{
			return  OnKeyDown(key);
		}
	}





else
	{
		
		ResetKeyPressed();
	}

	return  super.OnKey(key, up);

}


public boolean IsMenuScene() {
 return  false; 
}


public boolean HandleCommand (int command) {

	

	 boolean handled = true;

	switch(command)
	{
		case (((int)ConstantsEnglishPortrait.selectCommand == (int)ConstantsEnglishLandscape.selectCommand) ? Constants.selectCommand : -123) :
		{

















}
		break;

		case (((int)ConstantsEnglishPortrait.goToPauseSceneCommand == (int)ConstantsEnglishLandscape.goToPauseSceneCommand) ? Constants.goToPauseSceneCommand : -123) :
		{
			
			
			if(mGameSceneState == kDisplayGameOver)
			{
				command = (((int)ConstantsEnglishPortrait.goToGameOverMenuCommand == (int)ConstantsEnglishLandscape.goToGameOverMenuCommand) ? Constants.goToGameOverMenuCommand : ConstantsGetter.GetConstants().goToGameOverMenuCommandFct());
			}
			handled = super.HandleCommand(command);
		}
		break;
































default :
		{
			handled = super.HandleCommand(command);
		}
		break;
	}

	return  handled;

}


public final static byte kDirLeft = 0;
public final static byte kDirRight = 1;
public final static byte kDirCount = 2;

public final static byte kGameOverStr = 0;
public final static byte kPlayer1Str = 1;
public final static byte kPlayer2Str = 2;
public final static byte kPlayer3Str = 3;
public final static byte kPlayer4Str = 4;
public final static byte kWaitForPlayerStr = 5;
public final static byte kOpponentIsPlayingStr = 6;
public final static byte kOpponentForfeitStr = 7;
public final static byte kGameStringsCount = 8;

public final static byte kWaitingOnResources = 0;
public final static byte kWaitingOnAnim = 1;
public final static byte kSuspended = 2;
public final static byte kReady = 3;
public final static byte kDisplayPlayerTurn = 4;
public final static byte kWaitingChallengeEndTurn = 5;
public final static byte kDisplayGameOver = 6;
public final static byte kWaitingOnUserInput = 7;

public final static byte kHudFirst = 0;
public final static byte kHudSecond = 1;
public final static byte kHudThird = 2;
public final static byte kHudCount = 3;

public final static byte kNone = 0;
public final static byte kGameOverAnimation = 1;
public final static byte kNextQueueAnimation = 2;
public final static byte kNextQueueLineRotation = 3;
public final static byte kOpponnentNextQueueLineRotation = 4;
public final static byte kGameStatusFlash = 5;
public final static byte kLevelUp = 6;
public final static byte kHardDropReboundAnimation = 7;
public final static byte kShowSpecialStatusOneLine = 8;
public final static byte kShowSpecialStatusTwoLines = 9;
public final static byte kAnimationCount = 10;

public final static byte kHudCircleNextSide = 0;
public final static byte kHudCircleHoldSide = 1;
public final static byte kHudCircleCount = 2;

public final static byte kIsReady = 0;
public final static byte kIsNotReady = 1;
public final static byte kIsGameOver = 2;

public void HandlePlayersMessages () {

	

	 TetrisPlayer player = GetTetrisState().GetPlayer(TetrisState.kPlayer1);
	 TetrisGame gameState = player.GetGameState();
	 TetrisApp tetrisApp = GetApp();



	
	if(player.GetInvalidatedState(TetrisPlayer.kInvalidateStartGame))
	{






}

	if(player.GetInvalidatedState(TetrisPlayer.kInvalidateOpponentGameSceneLoaded))
	{
		if(GetTetrisState().MustSyncGameStart())
		{
			
			mpGameStatusText.SetVisible(false);
		}
	}

	if(player.GetInvalidatedState(TetrisPlayer.kInvalidateTetriminoStartsFalling))
	{
		mpFallingPiece.SetTetrimino(gameState.GetFallingTetrimino());
		mpFallingPiece.UpdatePosition(); 

		if(mDisplayGhost)
		{
			mpGhostPiece.SetTetrimino(player.GetGhostTetrimino(), true);
			mpGhostPiece.SetVisible(false); 
		}








}

	if(	player.GetInvalidatedState(TetrisPlayer.kInvalidateSoftDrop) &&
		GetTetrisState().IsNeededToShowScore())
	{


UpdateScoreHUD();
}

	if(player.GetInvalidatedState(TetrisPlayer.kInvalidateFacing))
	{
		mpFallingPiece.UpdateFacing();
		mpGhostPiece.UpdateFacing();
	}


	if(player.GetInvalidatedState(TetrisPlayer.kInvalidateHardDrop))
	{
		 Tetrimino fallingTetrimino = gameState.GetFallingTetrimino();
		mpGhostPiece.SetTetrimino(null);

		
		 int fallingPieceBottom = mpFallingPiece.GetBottom();

		
		mpFallingPiece.UpdatePosition();

		
		 int fallingHeight = mpFallingPiece.GetBottom() - fallingPieceBottom;



		mpFallingPiece.SetTetrimino(null);
		mpBouncingPiece.SetTetrimino(fallingTetrimino);
		mpBouncingPiece.UpdatePosition();
if(fallingHeight > (((int)ConstantsEnglishPortrait.gameSceneHardDropMinHeightFactor == (int)ConstantsEnglishLandscape.gameSceneHardDropMinHeightFactor) ? Constants.gameSceneHardDropMinHeightFactor : ConstantsGetter.GetConstants().gameSceneHardDropMinHeightFactorFct()))
		{
			StartAnimation(kHardDropReboundAnimation);
			mpWellComponents[TetrisState.kPlayer1].StartHardDropAnim(fallingTetrimino, fallingHeight);


			
			
			mpParticleGenerator.StopHardDropParticles();
			for(int mino = 0;mino < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());mino ++)
			{
				 int minoMatrixX = fallingTetrimino.GetMatrixPosX() + fallingTetrimino.GetMinoX(mino);

				 int minoMatrixY = fallingTetrimino.GetMatrixPosY() + fallingTetrimino.GetMinoY(mino);


				if(minoMatrixY + 1>= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) ||	
					gameState.GetWell().IsBlockUsed(minoMatrixX, minoMatrixY + 1))
				{
					mpParticleGenerator.StartHardDropParticles(minoMatrixX, minoMatrixY + 1, fallingHeight);
				}
			}
}

		tetrisApp.GetPlayer().PlaySound(TetrisMediaPlayer.kSndHardDrop);
}
if(player.GetInvalidatedState(TetrisPlayer.kInvalidateTetriminoLock))
	{
		mpFallingPiece.SetTetrimino(null);
		mpGhostPiece.SetTetrimino(null);

		mpBouncingPiece.SetTetrimino(null);
if(!player.GetGameState().GetWell().HasCompleteLines())
		{
			mpHighlightPiece.OnTetriminoLock(gameState.GetFallingTetrimino(), mpHighlightPieceWindow);
		}
if(!gameState.IsHardDropping())
		{
			tetrisApp.GetPlayer().PlaySound(TetrisMediaPlayer.kSndLockDown);
		}





if(gameState.GetClearedLineCount() > 0&& !IsAboveNoAnimLevel())
		{
			mpParticleGenerator.InitializeClearLineParticles(gameState.GetClearedLineCount());
		}
}

	if(player.GetInvalidatedState(TetrisPlayer.kInvalidateEndTurn))
	{

	DisplayGameStatus(gameState.GetGameSpecialStatus());
if(mPlayingLevelUpSound)
		{
			
			mPlayingLevelUpSound = false;
		}
		else
		{
			 int nbClearedLines = gameState.GetClearedLineCount();

			if(nbClearedLines > 0)
			{








{
					tetrisApp.GetPlayer().PlayClearLineSnd(nbClearedLines, gameState.GetWell().IsLastShotTSpin());
				}
			}
		}
}














if(player.GetInvalidatedState(TetrisPlayer.kInvalidateTetriminoHold))
	{
		mpHoldedPiece.SetTetrimino(gameState.GetHoldedTetrimino());


		if(mpHoldedPiece.GetTetrimino() != null)
		{
			StartAnimation(kOpponnentNextQueueLineRotation);
		}






mpCircleIntensityViewport[kHudCircleHoldSide].SetVisible(mpHoldedPiece.GetTetrimino() != null);
tetrisApp.GetPlayer().PlaySound(TetrisMediaPlayer.kSndHold);
}

















if(player.GetInvalidatedState(TetrisPlayer.kInvalidateLevelUp))
	{

		if(IsAboveNoAnimLevel())
		{
			mpWellComponents[TetrisState.kPlayer1].SetClearLineAnimDisabled(true);
		}
tetrisApp.GetPlayer().PlaySound(TetrisMediaPlayer.kSndLevelUp);
		mPlayingLevelUpSound = true;
StartAnimation(kLevelUp);


}

	
	for(int i = 0;i < GetTetrisState().GetPlayerCount();i ++)
	{
		player = GetTetrisState().GetPlayer((byte)i);
		gameState = player.GetGameState();






if(player.GetInvalidatedState(TetrisPlayer.kInvalidateTetriminoStartsFalling))
		{















if(i == TetrisState.kPlayer1)
			{
				if(UpdateVisualQueue((byte)i))
				{

					StartAnimation(kNextQueueAnimation);
}
			}

		}






if(player.GetInvalidatedState(TetrisPlayer.kInvalidateGameOverResult))
		{





{
				
				byte loser;







{
					loser = TetrisState.kPlayer1;
				}

				 int gameOver = GetPlayerGameState(loser).GetGameOverType();


				mGameSceneState = kDisplayGameOver;

				 byte gameOverStr = kGameOverStr;







mpGameStatusText.SetCaption(new String(mpGameStrings[gameOverStr]));

				if(gameOver == TetrisGame.kGameOverLockOut || gameOver == TetrisGame.kGameOverTopOut || gameOver == TetrisGame.kGameOverBlockOut)
				{

					
					tetrisApp.GetPlayer().StopInGameMusic();
StartAnimation(kGameOverAnimation);
					
					
				
					tetrisApp.GetPlayer().PlayEndGameSound(loser != TetrisState.kPlayer1);




{
						if(loser == TetrisState.kPlayer1)
						{
							tetrisApp.GetPlayer().StartVibration((((int)ConstantsEnglishPortrait.vibrationNormalDurationMs == (int)ConstantsEnglishLandscape.vibrationNormalDurationMs) ? Constants.vibrationNormalDurationMs : ConstantsGetter.GetConstants().vibrationNormalDurationMsFct()));
						}
					}

}
				mGameSceneDelayMs = (((int)ConstantsEnglishPortrait.gameOverDisplayTimeMs == (int)ConstantsEnglishLandscape.gameOverDisplayTimeMs) ? Constants.gameOverDisplayTimeMs : ConstantsGetter.GetConstants().gameOverDisplayTimeMsFct()); 
				mpGameStatusText.SetVisible(true);
				StopAnimation(kGameStatusFlash);
			}


			mpGhostPiece.SetVisible(false);




























}


















































if(player.GetInvalidatedState(TetrisPlayer.kInvalidateEndTurn))
		{
			UpdatePieceLockHUD();










{
				
				UpdateDangerState((byte)i);
			}
}

		
		player.Validate();
	}

}


public boolean OnKeyUp (int key) {

	

	 boolean handled = true;






handled = false;
return  handled ? true : super.OnKey(key, true);

}


public boolean OnKeyDown (int key) {

	






return  super.OnKey(key, false);

}


public void ResetKeyPressed() {
 GetApp().ReleaseAllKeys(); 
}


public Text InitHud (int indexOffset, int labelPackageReference) {

	

	 Text labelText = null;
	(labelText)= (labelText).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameSceneHudL1LabelText_ID + 2* indexOffset), null);

	 String labelStr = null;
	(labelStr)= (labelStr).Cast((mpPackage).GetEntryPoint(labelPackageReference), null);

	labelText.SetCaption(new String(labelStr));

	 Text returnRef = null;
	(returnRef)= (returnRef).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameSceneHudL1NumberText_ID + 2* indexOffset), null);











return  returnRef;

}


public void UpdatePieceLockHUD () {

	



{
		if(GetTetrisState().IsNeededToShowLine())
		{
			 int lineCount = GetMainMatrixPlayerGameState().GetLineCount();

			mpLinesNumberText.SetCaption(new String(FlMath.Absolute(lineCount)));

			if(GetTetrisState().IsModeMarathon())
			{
				 int goalCount = GetMainMatrixPlayerGameState().GetGoal();


				
				
				if(goalCount < 0)
				{
					goalCount = 0;
				}

				mpGoalNumberText.SetCaption(new String(goalCount));
			}







}

	}

	if(GetTetrisState().IsNeededToShowScore())
	{
		UpdateScoreHUD();
	}

}


public void UpdateLevelHUD () {

	

	 int level = GetMainMatrixPlayerGameState().GetLevel();

	mpLevelNumberText.SetCaption(new String(level));


	 int timeFlowMult = mpMatrixBorderTimeSystem.GetTimeFlowSpeed().LessThan(F32.Zero(16)) ? -1 : 1;


	 F32 speedMult = new F32((int)(((int)ConstantsEnglishPortrait.speedMultFactor == (int)ConstantsEnglishLandscape.speedMultFactor) ? Constants.speedMultFactor : ConstantsGetter.GetConstants().speedMultFactorFct()), 16);

	mpMatrixBorderTimeSystem.SetTimeFlowSpeed(speedMult.Mul(level).Add(F32.One(16)).Mul(timeFlowMult));

}


public void UpdateScoreHUD () {

	



	 int player1Score = GetPlayer1GameState().GetScore();


	if(player1Score < (((int)ConstantsEnglishPortrait.maxDisplayScore == (int)ConstantsEnglishLandscape.maxDisplayScore) ? Constants.maxDisplayScore : ConstantsGetter.GetConstants().maxDisplayScoreFct()))
	{
		mpScoreNumberText.SetCaption(new String(player1Score));
	}
	else
	{
		mpScoreNumberText.SetCaption(new String((((int)ConstantsEnglishPortrait.maxDisplayScore == (int)ConstantsEnglishLandscape.maxDisplayScore) ? Constants.maxDisplayScore : ConstantsGetter.GetConstants().maxDisplayScoreFct())));
	}



























}


public void UpdateTimeHUD () {

	



	 int playTimeMs = GetMainMatrixPlayerGameState().GetPlayTimeMs();


	if(GetTetrisState().IsTimeCountDown())
	{
		playTimeMs = GetTetrisState().GetTimeLimit() - playTimeMs;

		if(playTimeMs < 0)
		{
			playTimeMs = 0;
		}
	}

	 String timeCaption = null;






{	
		 String formattedString = new String(StringToolbox.FormatTime(playTimeMs));

		timeCaption = new String(formattedString);
	}
	mpTimeNumberText.SetCaption(timeCaption);



















}


public boolean UpdateVisualQueue (byte playerQueue) {

	



 boolean pieceAlreadySet = mpNextPieceQueue[playerQueue][0].GetTetrimino() == GetPlayerGameState(playerQueue).GetPieceAt(0);




if(pieceAlreadySet)
	{
		return  false;
	}


	
	if(!mpNextQueueAnimationTimeSystem.IsPaused())
	{
		StopAnimation(kNextQueueAnimation);
	}
for(int i = 0;i < (((int)ConstantsEnglishPortrait.visualPieceQueueSize == (int)ConstantsEnglishLandscape.visualPieceQueueSize) ? Constants.visualPieceQueueSize : ConstantsGetter.GetConstants().visualPieceQueueSizeFct());i ++)
	{
		
		mpNextPieceQueue[playerQueue][i].SetTetrimino(GetPlayerGameState(playerQueue).GetPieceAt(i), false, (int)(i - 1));
	}



	mAnimatedQueue = playerQueue;
mpCircleIntensityViewport[playerQueue].SetVisible(mpNextPieceQueue[playerQueue][0].GetTetrimino() != null);
return  true;

}


public void UpdateWellForPhase (byte player, int deltaTimeMs, boolean ready) {

	

	 int gamePhase = GetPlayerGameState(player).GetGamePhase();

	if(ready || mpWellComponents[player].IsDoingAnimation())
	{
		mpWellComponents[player].UpdatePhase(gamePhase, deltaTimeMs);
	}

}


public byte NextGameSceneState () {

	

	 byte ready = kIsNotReady;


	switch((int)mGameSceneState)
	{
	case kWaitingOnResources :
		{






{
				mGameSceneState = kReady;
				ready = kIsReady;
			}
}
		break;

	case kWaitingOnAnim :
		if(mGameSceneCurrentAnim == kNone)
		{
			mGameSceneState = kReady;
			ready = kIsReady;
		}
		break;

	case kDisplayGameOver :
		{
			SaveOnExit();
			ready = kIsGameOver;








{
				HandleCommand((((int)ConstantsEnglishPortrait.goToGameOverMenuCommand == (int)ConstantsEnglishLandscape.goToGameOverMenuCommand) ? Constants.goToGameOverMenuCommand : ConstantsGetter.GetConstants().goToGameOverMenuCommandFct()));
			}
		}
		break;
















case kReady :
		{
			ready = kIsReady;
		}
		break;
	}

	return  ready;

}


public void SetGameSceneState (byte nextState) {

	

	mGameSceneState = nextState;

}


public void UpdateGameState (int deltaTimeMs) {

	

	GetTetrisState().OnTime(deltaTimeMs);

}


public void UpdateWellPhases (int deltaTimeMs, boolean ready) {

	

	 byte mainPlayer = TetrisState.kPlayer1;







UpdateWellForPhase(mainPlayer, deltaTimeMs, ready);







}


public void UpdateGameUI (int deltaTimeMs) {

	


	
	HandlePlayersMessages();


	
	 int gamePhase = GetMainMatrixPlayerGameState().GetGamePhase();

	if(	gamePhase == TetrisGame.kPhaseFalling ||
		gamePhase == TetrisGame.kPhaseLock)
	{


		if(mpGhostPiece.GetTetrimino() != null && !mpWellComponents[TetrisState.kPlayer1].IsDoingAnimation())
		{
			
			mpGhostPiece.SetVisible(true);
		}

		mpGhostPiece.UpdatePosition();

		
		mpFallingPiece.UpdatePosition();
	}






if(GetTetrisState().IsNeededToShowTime())
	{
		 int gameTime = GetMainMatrixPlayerGameState().GetPlayTimeMs();

		if(gameTime - mLastGameTimeUpdate > 1000)
		{
			mLastGameTimeUpdate += 1000;
			UpdateTimeHUD();
		}
	}













}


public void NextAnimationState () {

	


	switch((int)mGameSceneCurrentAnim)
	{
















case kNone :
	default :
		break;
	}








	if(mGameSceneState != kWaitingOnResources)
	{

		if(mpNextQueueAnimationTimeSystem != null)
		{
			if(!mpNextQueueAnimationTimeSystem.IsPaused() && mpNextQueueAnimationTimeSystem.GetTotalTime() >= (((int)ConstantsEnglishPortrait.nextQueueAnimationPeriod == (int)ConstantsEnglishLandscape.nextQueueAnimationPeriod) ? Constants.nextQueueAnimationPeriod : ConstantsGetter.GetConstants().nextQueueAnimationPeriodFct()))
			{
				StopAnimation(kNextQueueAnimation);

				StartAnimation(mAnimatedQueue == TetrisState.kPlayer1 ? kNextQueueLineRotation : kOpponnentNextQueueLineRotation);
}
		}
if(!mpLevelUpTimeSystem.IsPaused() && mpLevelUpTimeSystem.GetTotalTime() >= (((int)ConstantsEnglishPortrait.levelUpAnimationPeriod == (int)ConstantsEnglishLandscape.levelUpAnimationPeriod) ? Constants.levelUpAnimationPeriod : ConstantsGetter.GetConstants().levelUpAnimationPeriodFct()))
		{
			if(mUpdateLevel)
			{
				mUpdateLevel = false;
				mpLevelUpTimeSystem.SetTotalTime(0);
				UpdateLevelHUD();
			}
			else
			{
				StopAnimation(kLevelUp);
			}
		}
if(!mpHardDropReboundTimeSystem.IsPaused() && mpHardDropReboundTimeSystem.GetTotalTime() >= (((int)ConstantsEnglishPortrait.hardDropReboundPeriod == (int)ConstantsEnglishLandscape.hardDropReboundPeriod) ? Constants.hardDropReboundPeriod : ConstantsGetter.GetConstants().hardDropReboundPeriodFct()))
		{
			StopAnimation(kHardDropReboundAnimation);
		}

if(!mpSpecialStatusTimeSystem.IsPaused() && mpSpecialStatusTimeSystem.GetTotalTime() >= (((int)ConstantsEnglishPortrait.specialStatusVisibilityPeriod == (int)ConstantsEnglishLandscape.specialStatusVisibilityPeriod) ? Constants.specialStatusVisibilityPeriod : ConstantsGetter.GetConstants().specialStatusVisibilityPeriodFct()))
		{


			
			StopAnimation(kShowSpecialStatusOneLine);


}
if(!mpGameOverFillMatrixTimeSystem.IsPaused() && mpGameOverFillMatrixTimeSystem.GetTotalTime() >= (((int)ConstantsEnglishPortrait.gameOverDisplayTimeMs == (int)ConstantsEnglishLandscape.gameOverDisplayTimeMs) ? Constants.gameOverDisplayTimeMs : ConstantsGetter.GetConstants().gameOverDisplayTimeMsFct()))
		{
			StopAnimation(kGameOverAnimation);

		}
	}


}


public void StartAnimation (byte nextAnimation) {

	

	 boolean waitAnimation = false;


	switch((int)nextAnimation)
	{









case kNextQueueAnimation :
		{
			mpNextQueueAnimationTimeSystem.RegisterInGlobalTime();











 Controller pGenericControllers = null;
			for(int i = 0;i < (((int)ConstantsEnglishPortrait.visualPieceQueueSize == (int)ConstantsEnglishLandscape.visualPieceQueueSize) ? Constants.visualPieceQueueSize : ConstantsGetter.GetConstants().visualPieceQueueSizeFct()) - 1;i ++)
			{
				(pGenericControllers)= (pGenericControllers).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameSceneNextQueuePiecesControllerFirstPiece_ID + i), null);
				pGenericControllers.SetControlParameters(mpNextPieceQueue[mAnimatedQueue][i], componentPosition);

				(pGenericControllers)= (pGenericControllers).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.isometricFirstPieceIsoIndexController_ID + i), null);
				pGenericControllers.SetControlParameters(mpNextPieceQueue[mAnimatedQueue][i], (((int)ConstantsEnglishPortrait.isometricIndex == (int)ConstantsEnglishLandscape.isometricIndex) ? Constants.isometricIndex : ConstantsGetter.GetConstants().isometricIndexFct()));
}

			mpNextPieceQueue[mAnimatedQueue][(((int)ConstantsEnglishPortrait.visualPieceQueueSize == (int)ConstantsEnglishLandscape.visualPieceQueueSize) ? Constants.visualPieceQueueSize : ConstantsGetter.GetConstants().visualPieceQueueSizeFct()) - 1].SetVisible(false);
			TetrisApp.StartAndInitializeTimeSystem(mpNextQueueAnimationTimeSystem);

		}
	break;
case kOpponnentNextQueueLineRotation :
	case kNextQueueLineRotation :
		{
			 int hudCircle = (nextAnimation == kOpponnentNextQueueLineRotation ? kHudCircleHoldSide : kHudCircleNextSide);










TetrisApp.StartAndInitializeTimeSystem(mpNextQueueRotationTimeSystems[hudCircle]);
		}
		break;
case kLevelUp :






mUpdateLevel = true;
		mpLevelUpTimeSystem.RegisterInGlobalTime();
		TetrisApp.StartAndInitializeTimeSystem(mpLevelUpTimeSystem);
		break;
case kGameOverAnimation :


{
			
			byte loser;







{
				loser = TetrisState.kPlayer1;
			}

			mpWellComponents[loser].StopAllAnimations();
			 Controller pFillMatrixController = null;
			(pFillMatrixController)= (pFillMatrixController).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameSceneGameOverMatrixFillController_ID), null);
			pFillMatrixController.SetControlParameters(mpWellComponents[loser], (((int)ConstantsEnglishPortrait.gameOverBlockFill == (int)ConstantsEnglishLandscape.gameOverBlockFill) ? Constants.gameOverBlockFill : ConstantsGetter.GetConstants().gameOverBlockFillFct()));

			
			mpGameOverFillMatrixTimeSystem.RegisterInGlobalTime();
			TetrisApp.StartAndInitializeTimeSystem(mpGameOverFillMatrixTimeSystem);
		}
		break;


	case kHardDropReboundAnimation :
		{
			mpHardDropReboundTimeSystem.RegisterInGlobalTime();
			mpHardDropReboundController.SetIsAbsolute(true);
			mpHardDropReboundController.SetIsAbsolute(false);
			TetrisApp.StartAndInitializeTimeSystem(mpHardDropReboundTimeSystem);
		}
	break;
case kGameStatusFlash :
		TetrisApp.StartAndInitializeTimeSystem(mpGameStatusFlashTimeSystem);
		break;



	case kShowSpecialStatusOneLine :
	case kShowSpecialStatusTwoLines :
		
		if(!mpSpecialStatusSizeTimeSystem.IsPaused())
		{
			StopAnimation(kShowSpecialStatusOneLine);
		}

		 int timeSystemIndexOffset = nextAnimation == kShowSpecialStatusOneLine ? 0 : 1;

		mpSpecialStatusSizeTimeSystem = TetrisApp.GetAndRegisterAndStopTimeSystem(mpPackage, RSRC_gameScenePackage.statusTextOneLineTimeSystem_ID + timeSystemIndexOffset);
		TetrisApp.StartAndInitializeTimeSystem(mpSpecialStatusSizeTimeSystem, (((int)ConstantsEnglishPortrait.statusHighAnimationInitAnimation == (int)ConstantsEnglishLandscape.statusHighAnimationInitAnimation) ? Constants.statusHighAnimationInitAnimation : ConstantsGetter.GetConstants().statusHighAnimationInitAnimationFct()));



mpSpecialStatusTimeSystem.RegisterInGlobalTime();
		TetrisApp.StartAndInitializeTimeSystem(mpSpecialStatusTimeSystem);
		break;
}

	if(waitAnimation)
	{
		SetGameSceneState(kWaitingOnAnim);
	}

}


public void StopAnimation (byte stopAnimation) {

	

	switch(stopAnimation)
	{



















case kNextQueueAnimation :
		{



mpNextPieceQueue[mAnimatedQueue][((((int)ConstantsEnglishPortrait.visualPieceQueueSize == (int)ConstantsEnglishLandscape.visualPieceQueueSize) ? Constants.visualPieceQueueSize : ConstantsGetter.GetConstants().visualPieceQueueSizeFct()) - 1)].SetVisible(mpNextPieceQueue[mAnimatedQueue][((((int)ConstantsEnglishPortrait.visualPieceQueueSize == (int)ConstantsEnglishLandscape.visualPieceQueueSize) ? Constants.visualPieceQueueSize : ConstantsGetter.GetConstants().visualPieceQueueSizeFct()) - 1)].GetTetrimino() != null);
			TetrisApp.FinalizeAndStopTimeSystem(mpNextQueueAnimationTimeSystem, (((int)ConstantsEnglishPortrait.nextQueueAnimationPeriod == (int)ConstantsEnglishLandscape.nextQueueAnimationPeriod) ? Constants.nextQueueAnimationPeriod : ConstantsGetter.GetConstants().nextQueueAnimationPeriodFct()));
			mpNextQueueAnimationTimeSystem.UnRegisterInGlobalTime();
		}
		break;











case kLevelUp :
		TetrisApp.FinalizeAndStopTimeSystem(mpLevelUpTimeSystem);
		mpLevelUpTimeSystem.UnRegisterInGlobalTime();
		break;
case kHardDropReboundAnimation :
		{
			mpHardDropReboundTimeSystem.Stop();
			mpHardDropReboundTimeSystem.UnRegisterInGlobalTime();
		}
		break;
case kGameStatusFlash :
		mpGameStatusFlashTimeSystem.Stop();
		break;



	case kShowSpecialStatusOneLine :
	case kShowSpecialStatusTwoLines :
		TetrisApp.FinalizeAndStopTimeSystem(mpSpecialStatusSizeTimeSystem);
		mpSpecialStatusSizeTimeSystem.UnRegisterInGlobalTime();


TetrisApp.FinalizeAndStopTimeSystem(mpSpecialStatusTimeSystem);
		mpSpecialStatusTimeSystem.UnRegisterInGlobalTime();
		break;
case kGameOverAnimation :
		TetrisApp.FinalizeAndStopTimeSystem(mpGameOverFillMatrixTimeSystem, 1000);
		mpGameOverFillMatrixTimeSystem.UnRegisterInGlobalTime();
		break;
	default :
		break;
	}

}


public void UpdateDangerState (byte player) {

	

	if(GetPlayerGameState(player).GetWell().GetWellTop() <= (((int)ConstantsEnglishPortrait.matrixFillHeightForDanger == (int)ConstantsEnglishLandscape.matrixFillHeightForDanger) ? Constants.matrixFillHeightForDanger : ConstantsGetter.GetConstants().matrixFillHeightForDangerFct()))
	{
		if(!mDangerStateEnable[player])
		{
			SetDangerState(true, player);
		}
	}
	else
	{
		if(mDangerStateEnable[player])
		{
			SetDangerState(false, player);
		}
	}

}


public void SetDangerState (boolean enable, byte player) {

	

	mDangerStateEnable[player] = enable;

	if(player == TetrisState.kPlayer1)
	{
		 int enableBitmapReferenceOffset = 0;


		if(enable)
		{
			enableBitmapReferenceOffset = 1;
		}

		 Bitmap pNewBitmapState = null;
		 Sprite pSpriteToUpdate = null;

		
		for(int singleBitmapIndex = 0;singleBitmapIndex < (((int)ConstantsEnglishPortrait.sideToUpdateCount == (int)ConstantsEnglishLandscape.sideToUpdateCount) ? Constants.sideToUpdateCount : ConstantsGetter.GetConstants().sideToUpdateCountFct());singleBitmapIndex ++)
		{
			(pNewBitmapState)= (pNewBitmapState).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.matrixCornerBitmap_ID + (singleBitmapIndex * (((int)ConstantsEnglishPortrait.sideToUpdateCount == (int)ConstantsEnglishLandscape.sideToUpdateCount) ? Constants.sideToUpdateCount : ConstantsGetter.GetConstants().sideToUpdateCountFct())) + enableBitmapReferenceOffset), null);

			for(int componentIndex = 0;componentIndex < (((int)ConstantsEnglishPortrait.sideToUpdateCount == (int)ConstantsEnglishLandscape.sideToUpdateCount) ? Constants.sideToUpdateCount : ConstantsGetter.GetConstants().sideToUpdateCountFct());componentIndex ++)
			{
				(pSpriteToUpdate)= (pSpriteToUpdate).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.matrixLeftTopCornerComponent_ID + (singleBitmapIndex * (((int)ConstantsEnglishPortrait.sideToUpdateCount == (int)ConstantsEnglishLandscape.sideToUpdateCount) ? Constants.sideToUpdateCount : ConstantsGetter.GetConstants().sideToUpdateCountFct())) + componentIndex), null);
				pSpriteToUpdate.SetBitmap(pNewBitmapState);
			}
		}

		
		for(int borderSpriteIndex = 0;borderSpriteIndex < (((int)ConstantsEnglishPortrait.sideToUpdateCount == (int)ConstantsEnglishLandscape.sideToUpdateCount) ? Constants.sideToUpdateCount : ConstantsGetter.GetConstants().sideToUpdateCountFct());borderSpriteIndex ++)
		{
			(pNewBitmapState)= (pNewBitmapState).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.matrixLeftWallBitmap_ID + (borderSpriteIndex * (((int)ConstantsEnglishPortrait.sideToUpdateCount == (int)ConstantsEnglishLandscape.sideToUpdateCount) ? Constants.sideToUpdateCount : ConstantsGetter.GetConstants().sideToUpdateCountFct())) + enableBitmapReferenceOffset), null);
			(pSpriteToUpdate)= (pSpriteToUpdate).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.matrixLeftBorderComponent_ID + borderSpriteIndex), null);
			pSpriteToUpdate.SetBitmap(pNewBitmapState);
		}
		



		for(int borderSideIndex = 0;borderSideIndex < (((int)ConstantsEnglishPortrait.sideToUpdateCount == (int)ConstantsEnglishLandscape.sideToUpdateCount) ? Constants.sideToUpdateCount : ConstantsGetter.GetConstants().sideToUpdateCountFct());borderSideIndex ++)
		{
			(pNewBitmapState)= (pNewBitmapState).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.matrixLeftWallHighLightBitmap_ID + (borderSideIndex * (((int)ConstantsEnglishPortrait.sideToUpdateCount == (int)ConstantsEnglishLandscape.sideToUpdateCount) ? Constants.sideToUpdateCount : ConstantsGetter.GetConstants().sideToUpdateCountFct())) + enableBitmapReferenceOffset), null);

			for(int borderAnimationIndex = 0;borderAnimationIndex < (((int)ConstantsEnglishPortrait.borderWindowsComponentCount == (int)ConstantsEnglishLandscape.borderWindowsComponentCount) ? Constants.borderWindowsComponentCount : ConstantsGetter.GetConstants().borderWindowsComponentCountFct()) /(((int)ConstantsEnglishPortrait.sideToUpdateCount == (int)ConstantsEnglishLandscape.sideToUpdateCount) ? Constants.sideToUpdateCount : ConstantsGetter.GetConstants().sideToUpdateCountFct());borderAnimationIndex ++)
			{
			  (pSpriteToUpdate)= (pSpriteToUpdate).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.matrixFirstLeftBorderHighLightComponent_ID + (borderSideIndex * (((int)ConstantsEnglishPortrait.borderWindowsComponentCount == (int)ConstantsEnglishLandscape.borderWindowsComponentCount) ? Constants.borderWindowsComponentCount : ConstantsGetter.GetConstants().borderWindowsComponentCountFct()) /(((int)ConstantsEnglishPortrait.sideToUpdateCount == (int)ConstantsEnglishLandscape.sideToUpdateCount) ? Constants.sideToUpdateCount : ConstantsGetter.GetConstants().sideToUpdateCountFct())) + borderAnimationIndex), null);
			  pSpriteToUpdate.SetBitmap(pNewBitmapState);
			}
		}

		 int timeFlow = enable ? -1 : 1;

		 F32 currentSpeed = new F32(mpMatrixBorderTimeSystem.GetTimeFlowSpeed().Abs());


		mpMatrixBorderTimeSystem.SetTimeFlowSpeed(currentSpeed.Mul(timeFlow));
}













}


public byte GetMainMatrixPlayer () {

	

	return  TetrisState.kPlayer1;

}


public int GetVisualQueueCount () {

	






return  1;

}


public void SetupSpecialStatusDisplay (int stringEntryPoint) {

	

	if(!mpSpecialStatusTimeSystem.IsPaused())
	{

		
		StopAnimation(kShowSpecialStatusOneLine);


}

	 String pStatusString = null;
	(pStatusString)= (pStatusString).Cast((mpPackage).GetEntryPoint(stringEntryPoint), null);

	 Text pGreenText = null;
	 Text pWhiteText = null;
	(pGreenText)= (pGreenText).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.specialStatusTextWhite_ID), null);
	(pWhiteText)= (pWhiteText).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.specialStatusTextGreen_ID), null);
	pWhiteText.SetCaption(new String(pStatusString));

	if(pWhiteText.GetNbLines() > 1)
	{
		
		 String greenText = new String();
		greenText.Assign(pWhiteText.GetLineString(0));
		StringToolbox.AssignToRightTrim(greenText);
		pGreenText.SetCaption(greenText);
		pGreenText.SetVisible(true);
	}
	else
	{
		pGreenText.SetVisible(false);
	}

	 Viewport pStatusViewport = null;
	(pStatusViewport)= (pStatusViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.gameSceneSpecialStatusViewport_ID), null);
	pStatusViewport.SetSize(pWhiteText.GetSize());

	StartAnimation(pWhiteText.GetRectHeight() > (((int)ConstantsEnglishPortrait.gameSceneStatusTextHeight == (int)ConstantsEnglishLandscape.gameSceneStatusTextHeight) ? Constants.gameSceneStatusTextHeight : ConstantsGetter.GetConstants().gameSceneStatusTextHeightFct()) ? kShowSpecialStatusTwoLines : kShowSpecialStatusOneLine);



}


public void DisplayGameStatus (int infoType) {

	

	if(infoType != TetrisGame.kNone && (!IsAboveNoAnimLevel()))
	{
		SetupSpecialStatusDisplay(RSRC_gameScenePackage.tSpinStr_ID + infoType);
		mpSpecialStatusTimeSystem.SetTimeFlowSpeed(F32.One(16));
	}

}


public boolean IsAboveNoAnimLevel() {
 return  (GetPlayer1GameState().GetLevel() >= (((int)ConstantsEnglishPortrait.disableAnimsAboveLevelNum == (int)ConstantsEnglishLandscape.disableAnimsAboveLevelNum) ? Constants.disableAnimsAboveLevelNum : ConstantsGetter.GetConstants().disableAnimsAboveLevelNumFct())); 
}


public TetrisGame GetMainMatrixPlayerGameState() {
 return  GetPlayerGameState(GetMainMatrixPlayer()); 
}


public boolean OnMsg (Component source, int msg, int intParam) {

	 Vector2_short tempCoord2 = new Vector2_short(FlPenManager.Get().GetPenPosition(intParam));



	if(msg == Component.penDownMsg)
	{
		OnPenDown(tempCoord2);
		return  true;
	}
	else if(msg == Component.penUpMsg)
	{
		OnPenUp(tempCoord2);
		return  true;
	}
	else if(msg == Component.penDragMsg)
	{
		OnPenDrag(tempCoord2, source, msg, intParam);
		return  true;
	}

	return  super.OnMsg(source, msg, intParam);

}


public void OnPenDown ( Vector2_short ptIn) {

	Viewport holdViewport = null;

	(holdViewport)= (holdViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.holdViewport_ID), null);

	Viewport ccwRotationViewport = null;

	(ccwRotationViewport)= (ccwRotationViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.ccwRotationViewport_ID), null);

	Viewport cwRotationViewport = null;

	(cwRotationViewport)= (cwRotationViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.cwRotationViewport_ID), null);

	Viewport leftMoveViewport = null;

	(leftMoveViewport)= (leftMoveViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.leftMoveViewport_ID), null);

	Viewport rightMoveViewport = null;

	(rightMoveViewport)= (rightMoveViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.rightMoveViewport_ID), null);

	Viewport dropViewport = null;

	(dropViewport)= (dropViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.dropViewport_ID), null);

	Viewport hardDropViewport = null;

	(hardDropViewport)= (hardDropViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.hardDropViewport_ID), null);

	if(isPenOnComponent(holdViewport, ptIn))
	{
		GetApp().OnKey(Key.SPACE, false);
	}
	else if(isPenOnComponent(hardDropViewport, ptIn))
	{
		GetApp().OnKey(Key.UP_R, false);
	}
	else if(isPenOnComponent(ccwRotationViewport, ptIn))
	{
		GetApp().OnKey(Key.UP_E, false);
	}
	else if(isPenOnComponent(cwRotationViewport, ptIn))
	{
		GetApp().OnKey(Key.UP_T, false);
	}
	else if(isPenOnComponent(leftMoveViewport, ptIn))
	{
		mIsMovingLeft = true;
		GetApp().OnKey(Key.UP_D, false);
	}
	else if(isPenOnComponent(rightMoveViewport, ptIn))
	{
		mIsMovingRight = true;
		GetApp().OnKey(Key.UP_G, false);
	}
	else if(isPenOnComponent(dropViewport, ptIn))
	{
		mIsSoftDropping = true;
		GetApp().OnKey(Key.UP_C, false);
	}

}


public void OnPenUp ( Vector2_short ptIn) {

	Viewport leftMoveViewport = null;

	(leftMoveViewport)= (leftMoveViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.leftMoveViewport_ID), null);

	Viewport rightMoveViewport = null;

	(rightMoveViewport)= (rightMoveViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.rightMoveViewport_ID), null);

	Viewport dropViewport = null;

	(dropViewport)= (dropViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.dropViewport_ID), null);

	Viewport resetKeyPressedViewport = null;

	(resetKeyPressedViewport)= (resetKeyPressedViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.resetKeyPressedViewport_ID), null);

	Viewport pauseViewport = null;

	(pauseViewport)= (pauseViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.pauseViewport_ID), null);

	if(isPenOnComponent(pauseViewport, ptIn) && ptIn.GetX() > (((int)ConstantsEnglishPortrait.screenWidth == (int)ConstantsEnglishLandscape.screenWidth) ? Constants.screenWidth : ConstantsGetter.GetConstants().screenWidthFct()) /3* 2)
	{	
		FlPenManager.Get().Deactivate();
		OnKey(Key.CLEAR, false);
		OnKey(Key.CLEAR, true);
	}
	else if(isPenOnComponent(leftMoveViewport, ptIn))
	{
		mIsMovingLeft = false;
		GetApp().OnKey(Key.UP_D, true);
	}
	else if(isPenOnComponent(rightMoveViewport, ptIn))
	{
		mIsMovingRight = false;
		GetApp().OnKey(Key.UP_G, true);
	}
	else if(isPenOnComponent(dropViewport, ptIn))
	{
		mIsSoftDropping = false;
		GetApp().OnKey(Key.UP_C, true);
	}
	else if(isPenOnComponent(resetKeyPressedViewport, ptIn))
	{
		ResetKeyPressed();
	}

	
	if(mIsMovingLeft)
	{
		mIsMovingLeft = false;
		GetApp().OnKey(Key.UP_D, true);
	}

	if(mIsMovingRight)
	{
		mIsMovingRight = false;
		GetApp().OnKey(Key.UP_G, true);
	}

	if(mIsSoftDropping)
	{
		mIsSoftDropping = false;
		GetApp().OnKey(Key.UP_C, true);
	}


}


public void OnPenDrag ( Vector2_short ptIn, Component source, int msg, int intParam) {





	if(mIsMovingLeft)
	{
		Viewport leftMoveViewport = null;

		(leftMoveViewport)= (leftMoveViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.leftMoveViewport_ID), null);

		if(! isPenOnComponent(leftMoveViewport, ptIn))
		{
			mIsMovingLeft = false;
			GetApp().OnKey(Key.UP_D, true);
		}
	}
	else if(mIsMovingRight)
	{
		Viewport rightMoveViewport = null;

		(rightMoveViewport)= (rightMoveViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.rightMoveViewport_ID), null);

		if(! isPenOnComponent(rightMoveViewport, ptIn))
		{
			mIsMovingRight = false;
			GetApp().OnKey(Key.UP_G, true);
		}
	}
	else if(mIsSoftDropping)
	{
		Viewport dropViewport = null;

		(dropViewport)= (dropViewport).Cast((mpPackage).GetEntryPoint(RSRC_gameScenePackage.dropViewport_ID), null);

		if(! isPenOnComponent(dropViewport, ptIn))
		{
			mIsSoftDropping = false;
			GetApp().OnKey(Key.UP_C, true);
		}
	}

	

}


public boolean isPenOnComponent (Component componentToVerify, Vector2_short inPoint) {

	return  isPenOnComponent(componentToVerify, inPoint, 0, 0, 0, 0);

}


public boolean isPenOnComponentDoubleSize (Component componentToVerify, Vector2_short inPoint) {

	return  isPenOnComponent(componentToVerify, inPoint, componentToVerify.GetRectHeight(), componentToVerify.GetRectHeight(), componentToVerify.GetRectWidth(), componentToVerify.GetRectWidth());

}


public boolean isPenOnComponent (Component componentToVerify, Vector2_short inPoint, int expandValUp, int expandValDown, int expandValLeft, int expandValRight) {

	if(componentToVerify != null)
	{	
		 FlRect rectCurrentSelection = new FlRect(componentToVerify.GetRect());
	

		 short myRect_left = (short)(componentToVerify.GetAbsoluteLeft() - expandValLeft);
  short myRect_top = (short)(componentToVerify.GetAbsoluteTop() - expandValUp);
  short myRect_width = (short)(rectCurrentSelection.GetWidth() + expandValLeft + expandValRight);
  short myRect_height = (short)(rectCurrentSelection.GetHeight() + expandValUp + expandValDown);
				
if(FlRect.Contains(myRect_left, myRect_top, myRect_width, myRect_height, (short)inPoint.GetX(), (short)inPoint.GetY()))
		{
			return  true;	
		}
	}
	return  false;

}


public WellComponent[] mpWellComponents = new WellComponent[TetrisState.kPlayerCount];

public Piece mpFallingPiece;
public Piece mpHoldedPiece;
public Piece mpGhostPiece;
public boolean mDisplayGhost;
public Piece mpHighlightPiece;
public WindowViewport mpHighlightPieceWindow;
public Piece[][] mpNextPieceQueue = new Piece[TetrisState.kPlayerCount][(((int)ConstantsEnglishPortrait.visualPieceQueueSize == (int)ConstantsEnglishLandscape.visualPieceQueueSize) ? Constants.visualPieceQueueSize : -123)];

public Viewport mpMainPieceQueueViewport;
public Text mpLevelNumberText;
public Text mpLinesNumberText;
public Text mpScoreNumberText;
public Text mpGoalNumberText;
public Text mpTimeNumberText;
public Text mpGameStatusText;
public TimeSystem mpGameStatusFlashTimeSystem;
public ParticleGenerator mpParticleGenerator;
public String[] mpGameStrings = new String[kGameStringsCount];

public int mLastGameTimeUpdate;
public TimeSystem mpHardDropReboundTimeSystem;
public Piece mpBouncingPiece;
public KeyFrameController mpHardDropReboundController;
public TimeSystem mpLevelUpTimeSystem;
public boolean mUpdateLevel;
public TimeSystem mpMatrixBorderTimeSystem;
public WindowViewport[] mpMatrixBorderWindowViewport = new WindowViewport[(((int)ConstantsEnglishPortrait.borderWindowsComponentCount == (int)ConstantsEnglishLandscape.borderWindowsComponentCount) ? Constants.borderWindowsComponentCount : -123)];

public byte mAnimatedQueue;
public TimeSystem mpNextQueueAnimationTimeSystem;
public TimeSystem[] mpNextQueueRotationTimeSystems = new TimeSystem[kHudCircleCount];

public Viewport[] mpCircleIntensityViewport = new Viewport[kHudCircleCount];

public byte mGameSceneCurrentAnim;
public byte mGameSceneState;
public boolean[] mDangerStateEnable = new boolean[TetrisState.kPlayerCount];

public TimeSystem mpGameOverFillMatrixTimeSystem;
public int mGameSceneDelayMs;
public boolean mPlayingLevelUpSound;
public TimeSystem mpSpecialStatusTimeSystem;
public WindowViewport mpStatusTextHighAnimationWindowViewport;
public TimeSystem mpSpecialStatusSizeTimeSystem;
public boolean mIsMovingLeft;
public boolean mIsMovingRight;
public boolean mIsSoftDropping;



}

