package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class MinoSprite extends Component {

public  MinoSprite (Package pMinoPackage) {
mpMinoPackage = pMinoPackage;


	 int minoSize = 0;

	(minoSize)= ((pMinoPackage).GetEntryPoint(RSRC_playerMinoPackage.playerMinoSize_ID, (int [])null));

	SetSize((short)minoSize, (short)minoSize);

	
	SetMinoColor((byte)0);

}


public void destruct() {

	mpMinoBitmapMap = null;

}


public void SetMinoColor (byte minoColor) {

	mpMinoBitmapMap = GetBitmapForMinoColor(mpMinoPackage, minoColor);	

}


public void OnDraw (DisplayContext displayContext) {


	
	if(!TetrisApp.IsInClippingRect(displayContext, mRect_left, mRect_top, mRect_width, mRect_height))
	{
		return ;
	}
DrawMino(displayContext, mpMinoBitmapMap, mSticky, mRect_left, mRect_top, mRect_width, mRect_height);

}


public void SetSticky(byte sticky) {
 mSticky = sticky; 
}


public static BitmapGroup GetBitmapForMinoColor (Package pMinoPackage, byte minoColor) {

	
	
	 BitmapGroup pMinoBitmapMap = null;

	(pMinoBitmapMap)= (pMinoBitmapMap).Cast((pMinoPackage).GetEntryPoint(RSRC_playerMinoPackage.minoLightBlueBitmapMap_ID + minoColor), null);
	
	return  pMinoBitmapMap;

}


public static void DrawMino (DisplayContext displayContext, BitmapGroup pMinoBitmapMap, byte sticky, short destRect_left, short destRect_top, short destRect_width, short destRect_height) {









 int minoPartFlags = 0;


	
	if(true) { minoPartFlags |= (1<< kMinoPartCenter); }   	
	if((sticky & kNeighborWest) == 0) { minoPartFlags |= (1<< kMinoPartWest); }
	if((sticky & kNeighborSouth) == 0) { minoPartFlags |= (1<< kMinoPartSouth); }
	if((sticky & kNeighborEast) == 0) { minoPartFlags |= (1<< kMinoPartEast); }
	if((sticky & kNeighborNorth) == 0) { minoPartFlags |= (1<< kMinoPartNorth); }
	
	
	
	 int neighborNorthWest = sticky & (kNeighborNorth | kNeighborWest);

	 int neighborSouthEast = sticky & (kNeighborSouth | kNeighborEast);

	if(neighborNorthWest != 0&& neighborNorthWest != (kNeighborNorth | kNeighborWest)) { minoPartFlags |= (1<< kMinoPartNorthWest); }	
	if(neighborSouthEast != 0&& neighborSouthEast != (kNeighborSouth | kNeighborEast)) { minoPartFlags |= (1<< kMinoPartSouthEast); }

	
	for(int i = 0;i < kMinoPartCount;i ++)
	{
		if(((minoPartFlags & (1<< i)) != 0))
		{
			pMinoBitmapMap.DrawElementAt(i, displayContext, destRect_left, destRect_top, destRect_width, destRect_height, (short)255, false, false);
		}
	}

}


public final static int kMinoPartCenter = 0;
public final static int kMinoPartNorth = 1;
public final static int kMinoPartEast = 2;
public final static int kMinoPartSouth = 3;
public final static int kMinoPartWest = 4;
public final static int kMinoPartNorthWest = 5;
public final static int kMinoPartSouthEast = 6;
public final static int kMinoPartCount = 7;

public final static int kNeighborWest = 1;
public final static int kNeighborSouth = 2;
public final static int kNeighborEast = 4;
public final static int kNeighborNorth = 8;

public Package mpMinoPackage;
public BitmapGroup mpMinoBitmapMap;
public byte mSticky;



}

