package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class MultiTargetTypes {

public final static byte none = 0;
public final static byte language = 1;
public final static byte resolution = 2;
public final static byte languageResolution = 3;
public final static byte count = 4;


/* One dimension array */
public static MultiTargetTypes[] InstArrayMultiTargetTypes(int size) {
	MultiTargetTypes[] newArray = new MultiTargetTypes[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new MultiTargetTypes();
	return newArray; }

/* Two dimension array */
public static MultiTargetTypes[][] InstArrayMultiTargetTypes(int size1, int size2) {
	MultiTargetTypes[][] newArray = new MultiTargetTypes[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new MultiTargetTypes[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new MultiTargetTypes(); }
	return newArray; }

/* Three dimension array */
public static MultiTargetTypes[][][] InstArrayMultiTargetTypes(int size1, int size2, int size3) {
	MultiTargetTypes[][][] newArray = new MultiTargetTypes[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new MultiTargetTypes[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new MultiTargetTypes[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new MultiTargetTypes(); } }
	return newArray; }

public MultiTargetTypes () { 
}




}

