package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class TetriminoI extends Tetrimino {

public  TetriminoI (Well pWell) {
super(pWell);


	mMinosX[0] = 0;
	mMinosY[0] = 0;
	mMinosX[1] = 1;
	mMinosY[1] = 0;
	mMinosX[2] = 2;
	mMinosY[2] = 0;
	mMinosX[3] = -1;
	mMinosY[3] = 0;

	






}


public boolean IsFree (int adjX, int adjY, int newFacingDir) {

	 Well well = mpWell;
	 short x = (short)(mMatrixPosX + adjX);

	 short y = (short)(mMatrixPosY + adjY);

	
	switch((int)newFacingDir) 
	{
	case kPieceFaceN :
		if(	x < 1||
			x >= (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()) -2||
			y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) ||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoINorthSouthMask == (int)ConstantsEnglishLandscape.tetriminoINorthSouthMask) ? Constants.tetriminoINorthSouthMask : ConstantsGetter.GetConstants().tetriminoINorthSouthMaskFct()), (x-1), y))
		{
			return  false;
		}
		break;
	case kPieceFaceE :
		if( x < 0||
			x >= (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()) ||
			y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) -2||
			well.IsBlockUsed(x, y-1) ||
			well.IsBlockUsed(x, y) ||
			well.IsBlockUsed(x, y+1) ||
			well.IsBlockUsed(x, y+2))
		{
			return  false;
		}
		break;
	case kPieceFaceS :
		if( x < 2||
			x >= (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()) -1||
			y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) ||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoINorthSouthMask == (int)ConstantsEnglishLandscape.tetriminoINorthSouthMask) ? Constants.tetriminoINorthSouthMask : ConstantsGetter.GetConstants().tetriminoINorthSouthMaskFct()), (x-2), y))
		{
			return  false;
		}
		break;
	case kPieceFaceW :
		if(	x < 0||
			x >= (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()) ||
			y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) -1||
			well.IsBlockUsed(x, y-2) ||
			well.IsBlockUsed(x, y-1) ||
			well.IsBlockUsed(x, y) ||
			well.IsBlockUsed(x, y+1))
		{
			return  false;
		}
		break;
	}
	
	return  true;

}


public boolean CanFall () {
	
	 Well well = mpWell;

	 short x = mMatrixPosX;

	 short y = mMatrixPosY;


	switch((int)mFacingDir) 
	{
	case kPieceFaceN :
		if(	y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 1||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoINorthSouthMask == (int)ConstantsEnglishLandscape.tetriminoINorthSouthMask) ? Constants.tetriminoINorthSouthMask : ConstantsGetter.GetConstants().tetriminoINorthSouthMaskFct()), (x-1), y+1))
		{
			return  false;
		}
		break;
	case kPieceFaceE :
		if(y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 3||
			well.IsBlockUsed(x, y+3))
		{
			return  false;
		}
		break;
	case kPieceFaceS :
		if(y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 1||
			well.IsMaskUsed((((int)ConstantsEnglishPortrait.tetriminoINorthSouthMask == (int)ConstantsEnglishLandscape.tetriminoINorthSouthMask) ? Constants.tetriminoINorthSouthMask : ConstantsGetter.GetConstants().tetriminoINorthSouthMaskFct()), (x-2), y+1))
		{
			return  false;
		}
		break;
	case kPieceFaceW :
		if(y >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 2||
			well.IsBlockUsed(x, y+2))
		{
			return  false;
		}
		break;
	}
	
	return  true;	

}


public int GetType() {
 return  kTetriminoI; 
}


public byte GetMinoColor() {
 return  (byte)(((int)ConstantsEnglishPortrait.minoTypeLightBlue == (int)ConstantsEnglishLandscape.minoTypeLightBlue) ? Constants.minoTypeLightBlue : ConstantsGetter.GetConstants().minoTypeLightBlueFct()); 
}





}

