package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class WellComponent extends Viewport {

public final static int MAX_LINE_GROUP_COUNT = 2;

public  WellComponent (Well wellState, Package pMinoPackage, boolean mainWell) {
mpWellState = wellState;
mUIGamePhase = (TetrisGame.kPhaseWaitingForStart);
mMainWell = (mainWell);
mCurrentAnimation = (kNoAnimation);


	(mMinoSize)= ((pMinoPackage).GetEntryPoint(RSRC_playerMinoPackage.playerMinoSize_ID, (int [])null));

	 int marginOffset = 0;

	if(mainWell)
	{
		marginOffset = (((int)ConstantsEnglishPortrait.playerMatrixMarginSize == (int)ConstantsEnglishLandscape.playerMatrixMarginSize) ? Constants.playerMatrixMarginSize : ConstantsGetter.GetConstants().playerMatrixMarginSizeFct());
	}

	for(int row = 0;row < (((int)ConstantsEnglishPortrait.wellVisibleHeight == (int)ConstantsEnglishLandscape.wellVisibleHeight) ? Constants.wellVisibleHeight : ConstantsGetter.GetConstants().wellVisibleHeightFct());row ++)
	{
		 int stateRow = row + (((int)ConstantsEnglishPortrait.wellSkyline == (int)ConstantsEnglishLandscape.wellSkyline) ? Constants.wellSkyline : ConstantsGetter.GetConstants().wellSkylineFct());

		mpLines[row] = new WellLineComponent(wellState.GetLineConst(stateRow), pMinoPackage);
		mpLines[row].SetViewport(this);
		mpLines[row].SetTopLeft((short)marginOffset, (short)(marginOffset + row * mMinoSize));
	}

	 int sizeOffset = 0;

	if(mainWell)
	{
		sizeOffset = (((int)ConstantsEnglishPortrait.playerMinoDeltaSize == (int)ConstantsEnglishLandscape.playerMinoDeltaSize) ? Constants.playerMinoDeltaSize : ConstantsGetter.GetConstants().playerMinoDeltaSizeFct());
	}
	SetSize((short)(mMinoSize * (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()) + sizeOffset), (short)(mMinoSize * (((int)ConstantsEnglishPortrait.wellVisibleHeight == (int)ConstantsEnglishLandscape.wellVisibleHeight) ? Constants.wellVisibleHeight : ConstantsGetter.GetConstants().wellVisibleHeightFct()) + sizeOffset));


	if(mainWell)
	{
		 Package pGameScenePackage = RessourcesManager.Get().GetPackage(PackageID.gameScene, false);

		
		 Viewport pClear1LineViewport = null;
		(pClear1LineViewport)= (pClear1LineViewport).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoClear1LineViewport_ID), null);

		mpClear1LineMultiDisplay = new MultiDisplayComponent((((int)ConstantsEnglishPortrait.minoClear1LineMaximumLineCount == (int)ConstantsEnglishLandscape.minoClear1LineMaximumLineCount) ? Constants.minoClear1LineMaximumLineCount : ConstantsGetter.GetConstants().minoClear1LineMaximumLineCountFct()));

		mpClear1LineMultiDisplay.SetChild(pClear1LineViewport);
		mpClear1LineMultiDisplay.SetSize(pClear1LineViewport.GetRectWidth(), (short)(pClear1LineViewport.GetRectHeight() + (mMinoSize * ((((int)ConstantsEnglishPortrait.minoClear1LineMaximumLineSpan == (int)ConstantsEnglishLandscape.minoClear1LineMaximumLineSpan) ? Constants.minoClear1LineMaximumLineSpan : ConstantsGetter.GetConstants().minoClear1LineMaximumLineSpanFct()) - 1))));

		mpClear1LineTimeSystem = TetrisApp.GetAndRegisterAndStopTimeSystem(pGameScenePackage, RSRC_gameScenePackage.minoClear1LineTimeSystem_ID);

		int i;

		for(i = 0;i < (((int)ConstantsEnglishPortrait.minoClear1LineTSpinMaxMinoCount == (int)ConstantsEnglishLandscape.minoClear1LineTSpinMaxMinoCount) ? Constants.minoClear1LineTSpinMaxMinoCount : ConstantsGetter.GetConstants().minoClear1LineTSpinMaxMinoCountFct());i ++)
		{
			(mpClear1LineTSpinController[i])= (mpClear1LineTSpinController[i]).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoClear1LineTSpin1KeyFrameController_ID + i), null);
		}

		for(i = 0;i < (((int)ConstantsEnglishPortrait.minoClear1LineMaximumLineCount == (int)ConstantsEnglishLandscape.minoClear1LineMaximumLineCount) ? Constants.minoClear1LineMaximumLineCount : ConstantsGetter.GetConstants().minoClear1LineMaximumLineCountFct());i ++)
		{
			(mpClear1LineHideController[i])= (mpClear1LineHideController[i]).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoClear1LineHide1KeyFrameController_ID + i), null);
		}

		
		(mpClear2LinesViewport)= (mpClear2LinesViewport).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoClear2LinesViewport_ID), null);
		mpClear2LinesViewport.SetVisible(false);

		mpClear2LinesTimeSystem = TetrisApp.GetAndRegisterAndStopTimeSystem(pGameScenePackage, RSRC_gameScenePackage.minoClear2LinesTimeSystem_ID);

		for(i = 0;i < (((int)ConstantsEnglishPortrait.minoClear2LinesTSpinMinoCount == (int)ConstantsEnglishLandscape.minoClear2LinesTSpinMinoCount) ? Constants.minoClear2LinesTSpinMinoCount : ConstantsGetter.GetConstants().minoClear2LinesTSpinMinoCountFct());i ++)
		{
			(mpClear2LinesTSpinController[i])= (mpClear2LinesTSpinController[i]).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoClear2LinesTSpin1KeyFrameController_ID + i), null);
		}

		for(i = 0;i < (((int)ConstantsEnglishPortrait.minoClear2LinesMaximumLineCount == (int)ConstantsEnglishLandscape.minoClear2LinesMaximumLineCount) ? Constants.minoClear2LinesMaximumLineCount : ConstantsGetter.GetConstants().minoClear2LinesMaximumLineCountFct());i ++)
		{
			(mpClear2LinesHideController[i])= (mpClear2LinesHideController[i]).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoClear2LinesHide1KeyFrameController_ID + i), null);
		}

		
		 Viewport pClear3LinesViewport = null;
		(pClear3LinesViewport)= (pClear3LinesViewport).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoClear3LinesViewport_ID), null);

		mpClear3LinesMultiDisplay = new MultiDisplayComponent((((int)ConstantsEnglishPortrait.minoClear3LinesMaximumLineCount == (int)ConstantsEnglishLandscape.minoClear3LinesMaximumLineCount) ? Constants.minoClear3LinesMaximumLineCount : ConstantsGetter.GetConstants().minoClear3LinesMaximumLineCountFct()));

		mpClear3LinesMultiDisplay.SetChild(pClear3LinesViewport);
		mpClear3LinesMultiDisplay.SetSize(pClear3LinesViewport.GetRectWidth(), (short)(pClear3LinesViewport.GetRectHeight() + (mMinoSize * ((((int)ConstantsEnglishPortrait.minoClear3LinesMaximumLineCount == (int)ConstantsEnglishLandscape.minoClear3LinesMaximumLineCount) ? Constants.minoClear3LinesMaximumLineCount : ConstantsGetter.GetConstants().minoClear3LinesMaximumLineCountFct()) - 1))));
		mpClear3LinesMultiDisplay.SetVisible(false);

		(mpClear3LinesLightningViewport)= (mpClear3LinesLightningViewport).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoClear3LinesLightningViewport_ID), null);
		mpClear3LinesLightningViewport.SetVisible(false);

		mpClear3LinesTimeSystem = TetrisApp.GetAndRegisterAndStopTimeSystem(pGameScenePackage, RSRC_gameScenePackage.minoClear3LinesTimeSystem_ID);

		for(i = 0;i < (((int)ConstantsEnglishPortrait.minoClear3LinesMaximumLineCount == (int)ConstantsEnglishLandscape.minoClear3LinesMaximumLineCount) ? Constants.minoClear3LinesMaximumLineCount : ConstantsGetter.GetConstants().minoClear3LinesMaximumLineCountFct());i ++)
		{
			mpClear3LinesMultiDisplay.AddPosition(new Vector2_short((short)0, (short)(i * mMinoSize)));

			(mpClear3LinesHideController[i])= (mpClear3LinesHideController[i]).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoClear3LinesHide1KeyFrameController_ID + i), null);
		}

		
		 Viewport pClear4LinesViewport = null;
		(pClear4LinesViewport)= (pClear4LinesViewport).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoClear4LinesViewport_ID), null);

		mpClear4LinesMultiDisplay = new MultiDisplayComponent((((int)ConstantsEnglishPortrait.minoClear4LinesMaximumLineCount == (int)ConstantsEnglishLandscape.minoClear4LinesMaximumLineCount) ? Constants.minoClear4LinesMaximumLineCount : ConstantsGetter.GetConstants().minoClear4LinesMaximumLineCountFct()));

		mpClear4LinesMultiDisplay.SetChild(pClear4LinesViewport);
		mpClear4LinesMultiDisplay.SetSize(pClear4LinesViewport.GetRectWidth(), (short)(pClear4LinesViewport.GetRectHeight() + (mMinoSize * ((((int)ConstantsEnglishPortrait.minoClear4LinesMaximumLineCount == (int)ConstantsEnglishLandscape.minoClear4LinesMaximumLineCount) ? Constants.minoClear4LinesMaximumLineCount : ConstantsGetter.GetConstants().minoClear4LinesMaximumLineCountFct()) - 1))));
		mpClear4LinesMultiDisplay.SetVisible(false);

		mpClear4LinesTimerSequence = (TimerSequence)TetrisApp.GetAndRegisterAndStopTimeSystem(pGameScenePackage, RSRC_gameScenePackage.minoClear4LinesTimerSequence_ID);

		mpClear4LinesHideTimeSystem = TetrisApp.GetAndRegisterAndStopTimeSystem(pGameScenePackage, RSRC_gameScenePackage.minoClear4LinesHideTimeSystem_ID);



for(i = 0;i < (((int)ConstantsEnglishPortrait.minoClear4LinesMaximumLineCount == (int)ConstantsEnglishLandscape.minoClear4LinesMaximumLineCount) ? Constants.minoClear4LinesMaximumLineCount : ConstantsGetter.GetConstants().minoClear4LinesMaximumLineCountFct());i ++)
		{
			mpClear4LinesMultiDisplay.AddPosition(new Vector2_short((short)0, (short)(i * mMinoSize)));

			(mpClear4LinesHideController[i])= (mpClear4LinesHideController[i]).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoClear4LinesHide1KeyFrameController_ID + i), null);



}

		mpFallTimerSequence = new TimerSequence(MAX_LINE_GROUP_COUNT);
		mpFallTimerSequence.RegisterInGlobalTime();
		mpFallTimerSequence.Stop();

		for(i = 0;i < MAX_LINE_GROUP_COUNT;i ++)
		{
			mpLineGroupViewports[i] = new Viewport(this);

			mpFallControllers[i] = new KeyFrameController();
			mpFallControllers[i].SetControlParameters(mpLineGroupViewports[i], componentPosition);
			mpFallControllers[i].SetIsAbsolute(false);
		}

		mpAddLinesTimeSystem = TetrisApp.GetAndRegisterAndStopTimeSystem(pGameScenePackage, RSRC_gameScenePackage.minoAddLinesTimeSystem_ID);

		(mpAddLinesDustViewport)= (mpAddLinesDustViewport).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoAddLinesDustViewport_ID), null);
		mpAddLinesDustViewport.SetVisible(false);


		for(i = 0;i < (((int)ConstantsEnglishPortrait.minoHardDropReboundMaxMinoCount == (int)ConstantsEnglishLandscape.minoHardDropReboundMaxMinoCount) ? Constants.minoHardDropReboundMaxMinoCount : ConstantsGetter.GetConstants().minoHardDropReboundMaxMinoCountFct());i ++)
		{
			(mpHardDropReboundControllers[i])= (mpHardDropReboundControllers[i]).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoHardDropRebound1KeyFrameController_ID + i), null);
		}

		mpHardDropReboundTimeSystem = TetrisApp.GetAndRegisterAndStopTimeSystem(pGameScenePackage, RSRC_gameScenePackage.minoHardDropReboundTimeSystem_ID);
for(i = 0;i < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());i ++)
		{
			(mpHardDropTrailSprite[i])= (mpHardDropTrailSprite[i]).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.hardDropFirstTrailSprite_ID + i), null);
			mpHardDropTrailSprite[i].SetViewport(this);

			(mpHardDropTrailPosController[i])= (mpHardDropTrailPosController[i]).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.hardDropTrailPositionFirstController_ID + i), null);	
		}

		for(i = 0;i < (((int)ConstantsEnglishPortrait.hardDropTrailBitmapCount == (int)ConstantsEnglishLandscape.hardDropTrailBitmapCount) ? Constants.hardDropTrailBitmapCount : ConstantsGetter.GetConstants().hardDropTrailBitmapCountFct());i ++)
		{
			(mpHardDropTrailBitmap[i])= (mpHardDropTrailBitmap[i]).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.hardDropTrailLightBlueBitmap_ID + i), null);	
		}

		mpHardDropTrailTimeSystem = TetrisApp.GetAndRegisterAndStopTimeSystem(pGameScenePackage, RSRC_gameScenePackage.hardDropTrailTimeSystem_ID);
}
SetClipChildren(true);

	
	Update();

}


public void destruct() {

	

}


public void Term () {


	if(mMainWell)
	{
		StopAllAnimations();
		mpWellState.SetDoingAnimation(false);

		mpAddLinesTimeSystem.UnRegisterInGlobalTime();

		int i;

		for(i = 0;i < MAX_LINE_GROUP_COUNT;i ++)
		{
			mpFallControllers[i] = null;
		}

		mpFallTimerSequence.UnRegisterInGlobalTime();
		mpFallTimerSequence = null;

		
		mpClear1LineMultiDisplay.SetChild(null);
		mpClear1LineMultiDisplay = null;

		mpClear1LineTimeSystem.UnRegisterInGlobalTime();

		
		mpClear2LinesTimeSystem.UnRegisterInGlobalTime();

		
		mpClear3LinesMultiDisplay.SetChild(null);
		mpClear3LinesMultiDisplay = null;

		mpClear3LinesTimeSystem.UnRegisterInGlobalTime();

		
		mpClear4LinesMultiDisplay.SetChild(null);
		mpClear4LinesMultiDisplay = null;



mpClear4LinesTimerSequence.UnRegisterInGlobalTime();
		mpClear4LinesHideTimeSystem.UnRegisterInGlobalTime();


		mpHardDropReboundTimeSystem.UnRegisterInGlobalTime();
mpHardDropTrailTimeSystem.UnRegisterInGlobalTime();

		for(i = 0;i < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());i ++)
		{
			mpHardDropTrailSprite[i].SetViewport(null);
		}
}
for(int row = 0;row < (((int)ConstantsEnglishPortrait.wellVisibleHeight == (int)ConstantsEnglishLandscape.wellVisibleHeight) ? Constants.wellVisibleHeight : ConstantsGetter.GetConstants().wellVisibleHeightFct());row ++)
	{
		mpLines[row].SetViewport(null);
		mpLines[row].Term();
		mpLines[row] = null;
	}

	super.Term();

}


public void Update () {

	SynchWithState();

}


public void UpdatePhase (int gamePhase, int deltaTimeMs) {

	if(IsDoingAnimation())
	{
		

		if(gamePhase == TetrisGame.kPhaseFalling)
		{
			
			mAnimatingWhileTetriminoFalling = true;
		}
		else if(gamePhase == TetrisGame.kPhaseHardDropped && mAnimatingWhileTetriminoFalling)
		{
			
			StopAllAnimations();

			mAnimatingWhileTetriminoFalling = false;

			mUIGamePhase = gamePhase;
		}

		gamePhase = mUIGamePhase;
	}
	else
	{
		
		mUIGamePhase = gamePhase;

		mAnimatingWhileTetriminoFalling = false;
	}


	if(mMainWell)
	{
		if(gamePhase == TetrisGame.kPhaseLocked)
		{
			RunPhaseLockedNormal(deltaTimeMs);
		}
		else if(gamePhase == TetrisGame.kPhaseLinesCleared)
		{
			RunPhaseClearedLinesAnim();
		}
		else if(gamePhase == TetrisGame.kPhaseLinesAdded)
		{
			RunPhaseAddedLinesAnim();
		}

		CheckForEndOfAnimations();
	}
	else
if(gamePhase == TetrisGame.kPhaseLocked)
	{
		RunPhaseLockedNormal(deltaTimeMs);
	}
	else if(gamePhase == TetrisGame.kPhaseLinesCleared)
	{
		RunPhaseClearedLinesNormal(deltaTimeMs);
	}
	else if(gamePhase == TetrisGame.kPhaseLinesAdded)
	{
		RunPhaseAddedLinesNormal();
	}


	if(IsDoingAnimation())
	{
		InvalidateClearLinesAnimation();
	}

}


public void ControlValue (int valueCode, boolean setValue, Controller controller) {

	if(valueCode == (((int)ConstantsEnglishPortrait.gameOverBlockFill == (int)ConstantsEnglishLandscape.gameOverBlockFill) ? Constants.gameOverBlockFill : ConstantsGetter.GetConstants().gameOverBlockFillFct()))
	{		
		if(setValue)
		{
			 int value = controller.GetLongValue();


			if(mGameOverFillCurrentMino > value)
			{
				mGameOverFillCurrentMino = value;
			}

			while(mGameOverFillCurrentMino <= value)
			{
				 int minoLine = (((int)ConstantsEnglishPortrait.wellVisibleHeight == (int)ConstantsEnglishLandscape.wellVisibleHeight) ? Constants.wellVisibleHeight : ConstantsGetter.GetConstants().wellVisibleHeightFct()) - 1- (mGameOverFillCurrentMino / (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()));


				 int minoColumn = mGameOverFillCurrentMino % (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct());

				mpLines[minoLine].ForceMinoDisplay(minoColumn, (byte)(((int)ConstantsEnglishPortrait.minoTypeSolid == (int)ConstantsEnglishLandscape.minoTypeSolid) ? Constants.minoTypeSolid : ConstantsGetter.GetConstants().minoTypeSolidFct()));
				
				mpLines[minoLine].SetVisible(true);

				mGameOverFillCurrentMino++;
			}
		}
		else
		{
			controller.SetValue(mGameOverFillCurrentMino);
		}		
	}
	else
	{
		super.ControlValue(valueCode, setValue, controller);
	}

}


public boolean IsDoingAnimation () {

	return  mDisplayingTetriminoLocked || mDisplayingClearedLines || mCurrentAnimation != kNoAnimation;

}


public int GetMinoSize() {
 return  mMinoSize; 
}


public void StartAddLinesAnimation () {

	 Package pGameScenePackage = RessourcesManager.Get().GetPackage(PackageID.gameScene, false);


	mCurrentAnimation = kAddLinesAnimation;

	mpAddLinesDustViewport.SetVisible(true);
	mpAddLinesDustViewport.BringToFront();

	 int addedLineCount = mpWellState.GetLastShotAddedLineCount();

	 int firstAddedLine = (((int)ConstantsEnglishPortrait.wellVisibleHeight == (int)ConstantsEnglishLandscape.wellVisibleHeight) ? Constants.wellVisibleHeight : ConstantsGetter.GetConstants().wellVisibleHeightFct()) - addedLineCount;


	MakeLineGroup(0, firstAddedLine - 1, 0);
	MakeLineGroup(firstAddedLine, (((int)ConstantsEnglishPortrait.wellVisibleHeight == (int)ConstantsEnglishLandscape.wellVisibleHeight) ? Constants.wellVisibleHeight : ConstantsGetter.GetConstants().wellVisibleHeightFct()) - 1, 1);

	
	int[] destValues = {0, firstAddedLine * mMinoSize};
	 KeyFrameSequence pAddLinesDustRiseKeyFrameSequence = null;
	(pAddLinesDustRiseKeyFrameSequence)= (pAddLinesDustRiseKeyFrameSequence).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoAddLinesDustRiseKeyFrameSequence_ID), null);
	pAddLinesDustRiseKeyFrameSequence.SetKeyFrame(1, (short)(((int)ConstantsEnglishPortrait.minoAddLinesDustRisePeriod == (int)ConstantsEnglishLandscape.minoAddLinesDustRisePeriod) ? Constants.minoAddLinesDustRisePeriod : ConstantsGetter.GetConstants().minoAddLinesDustRisePeriodFct()), destValues);

	
	 KeyFrameSequence pAddLinesUpPartRiseKeyFrameSequence = null;
	(pAddLinesUpPartRiseKeyFrameSequence)= (pAddLinesUpPartRiseKeyFrameSequence).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoAddLinesUpPartRiseKeyFrameSequence_ID), null);
	int[] upPartTimes = {(((int)ConstantsEnglishPortrait.minoAddLinesUpPartRiseTime1 == (int)ConstantsEnglishLandscape.minoAddLinesUpPartRiseTime1) ? Constants.minoAddLinesUpPartRiseTime1 : ConstantsGetter.GetConstants().minoAddLinesUpPartRiseTime1Fct()), (((int)ConstantsEnglishPortrait.minoAddLinesUpPartRiseTime2 == (int)ConstantsEnglishLandscape.minoAddLinesUpPartRiseTime2) ? Constants.minoAddLinesUpPartRiseTime2 : ConstantsGetter.GetConstants().minoAddLinesUpPartRiseTime2Fct()), (((int)ConstantsEnglishPortrait.minoAddLinesUpPartRiseTime3 == (int)ConstantsEnglishLandscape.minoAddLinesUpPartRiseTime3) ? Constants.minoAddLinesUpPartRiseTime3 : ConstantsGetter.GetConstants().minoAddLinesUpPartRiseTime3Fct()), (((int)ConstantsEnglishPortrait.minoAddLinesUpPartRiseTime4 == (int)ConstantsEnglishLandscape.minoAddLinesUpPartRiseTime4) ? Constants.minoAddLinesUpPartRiseTime4 : ConstantsGetter.GetConstants().minoAddLinesUpPartRiseTime4Fct()), (((int)ConstantsEnglishPortrait.minoAddLinesUpPartRiseTime5 == (int)ConstantsEnglishLandscape.minoAddLinesUpPartRiseTime5) ? Constants.minoAddLinesUpPartRiseTime5 : ConstantsGetter.GetConstants().minoAddLinesUpPartRiseTime5Fct()), (((int)ConstantsEnglishPortrait.minoAddLinesUpPartRiseTime6 == (int)ConstantsEnglishLandscape.minoAddLinesUpPartRiseTime6) ? Constants.minoAddLinesUpPartRiseTime6 : ConstantsGetter.GetConstants().minoAddLinesUpPartRiseTime6Fct())};
	int[] upPartPositions = {(((int)ConstantsEnglishPortrait.minoAddLinesUpPartRisePosRatio1 == (int)ConstantsEnglishLandscape.minoAddLinesUpPartRisePosRatio1) ? Constants.minoAddLinesUpPartRisePosRatio1 : ConstantsGetter.GetConstants().minoAddLinesUpPartRisePosRatio1Fct()), (((int)ConstantsEnglishPortrait.minoAddLinesUpPartRisePosRatio2 == (int)ConstantsEnglishLandscape.minoAddLinesUpPartRisePosRatio2) ? Constants.minoAddLinesUpPartRisePosRatio2 : ConstantsGetter.GetConstants().minoAddLinesUpPartRisePosRatio2Fct()), (((int)ConstantsEnglishPortrait.minoAddLinesUpPartRisePosRatio3 == (int)ConstantsEnglishLandscape.minoAddLinesUpPartRisePosRatio3) ? Constants.minoAddLinesUpPartRisePosRatio3 : ConstantsGetter.GetConstants().minoAddLinesUpPartRisePosRatio3Fct()), (((int)ConstantsEnglishPortrait.minoAddLinesUpPartRisePosRatio4 == (int)ConstantsEnglishLandscape.minoAddLinesUpPartRisePosRatio4) ? Constants.minoAddLinesUpPartRisePosRatio4 : ConstantsGetter.GetConstants().minoAddLinesUpPartRisePosRatio4Fct()), (((int)ConstantsEnglishPortrait.minoAddLinesUpPartRisePosRatio5 == (int)ConstantsEnglishLandscape.minoAddLinesUpPartRisePosRatio5) ? Constants.minoAddLinesUpPartRisePosRatio5 : ConstantsGetter.GetConstants().minoAddLinesUpPartRisePosRatio5Fct()), (((int)ConstantsEnglishPortrait.minoAddLinesUpPartRisePosRatio6 == (int)ConstantsEnglishLandscape.minoAddLinesUpPartRisePosRatio6) ? Constants.minoAddLinesUpPartRisePosRatio6 : ConstantsGetter.GetConstants().minoAddLinesUpPartRisePosRatio6Fct())};
	int i;

	for(i = 0;i < (((int)ConstantsEnglishPortrait.minoAddLinesUpPartRiseKeyCount == (int)ConstantsEnglishLandscape.minoAddLinesUpPartRiseKeyCount) ? Constants.minoAddLinesUpPartRiseKeyCount : ConstantsGetter.GetConstants().minoAddLinesUpPartRiseKeyCountFct());i ++)
	{
		int[] values = {0, upPartPositions[i] * addedLineCount * mMinoSize / (((int)ConstantsEnglishPortrait.toFP16 == (int)ConstantsEnglishLandscape.toFP16) ? Constants.toFP16 : ConstantsGetter.GetConstants().toFP16Fct())};
		pAddLinesUpPartRiseKeyFrameSequence.SetKeyFrame(i, (short)upPartTimes[i], values);
	}

	
	 KeyFrameSequence pAddLinesDownPartRiseKeyFrameSequence = null;
	(pAddLinesDownPartRiseKeyFrameSequence)= (pAddLinesDownPartRiseKeyFrameSequence).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoAddLinesDownPartRiseKeyFrameSequence_ID), null);
	int[] downPartTimes = {(((int)ConstantsEnglishPortrait.minoAddLinesDownPartRiseTime1 == (int)ConstantsEnglishLandscape.minoAddLinesDownPartRiseTime1) ? Constants.minoAddLinesDownPartRiseTime1 : ConstantsGetter.GetConstants().minoAddLinesDownPartRiseTime1Fct()), (((int)ConstantsEnglishPortrait.minoAddLinesDownPartRiseTime2 == (int)ConstantsEnglishLandscape.minoAddLinesDownPartRiseTime2) ? Constants.minoAddLinesDownPartRiseTime2 : ConstantsGetter.GetConstants().minoAddLinesDownPartRiseTime2Fct()), (((int)ConstantsEnglishPortrait.minoAddLinesDownPartRiseTime3 == (int)ConstantsEnglishLandscape.minoAddLinesDownPartRiseTime3) ? Constants.minoAddLinesDownPartRiseTime3 : ConstantsGetter.GetConstants().minoAddLinesDownPartRiseTime3Fct())};
	int[] downPartPositions = {(((int)ConstantsEnglishPortrait.minoAddLinesDownPartRisePosRatio1 == (int)ConstantsEnglishLandscape.minoAddLinesDownPartRisePosRatio1) ? Constants.minoAddLinesDownPartRisePosRatio1 : ConstantsGetter.GetConstants().minoAddLinesDownPartRisePosRatio1Fct()), (((int)ConstantsEnglishPortrait.minoAddLinesDownPartRisePosRatio2 == (int)ConstantsEnglishLandscape.minoAddLinesDownPartRisePosRatio2) ? Constants.minoAddLinesDownPartRisePosRatio2 : ConstantsGetter.GetConstants().minoAddLinesDownPartRisePosRatio2Fct()), (((int)ConstantsEnglishPortrait.minoAddLinesDownPartRisePosRatio3 == (int)ConstantsEnglishLandscape.minoAddLinesDownPartRisePosRatio3) ? Constants.minoAddLinesDownPartRisePosRatio3 : ConstantsGetter.GetConstants().minoAddLinesDownPartRisePosRatio3Fct())};
	for(i = 0;i < (((int)ConstantsEnglishPortrait.minoAddLinesDownPartRiseKeyCount == (int)ConstantsEnglishLandscape.minoAddLinesDownPartRiseKeyCount) ? Constants.minoAddLinesDownPartRiseKeyCount : ConstantsGetter.GetConstants().minoAddLinesDownPartRiseKeyCountFct());i ++)
	{
		int[] values = {0, downPartPositions[i] * addedLineCount * mMinoSize / (((int)ConstantsEnglishPortrait.toFP16 == (int)ConstantsEnglishLandscape.toFP16) ? Constants.toFP16 : ConstantsGetter.GetConstants().toFP16Fct())};
		pAddLinesDownPartRiseKeyFrameSequence.SetKeyFrame(i, (short)downPartTimes[i], values);
	}

	 KeyFrameController pAddLinesDustRiseUpPartController = null;
	(pAddLinesDustRiseUpPartController)= (pAddLinesDustRiseUpPartController).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoAddLinesUpPartRiseKeyFrameController_ID), null);
	pAddLinesDustRiseUpPartController.SetControlParameters(mpLineGroupViewports[0], componentPosition);

	 KeyFrameController pAddLinesDustRiseDownPartController = null;
	(pAddLinesDustRiseDownPartController)= (pAddLinesDustRiseDownPartController).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoAddLinesDownPartRiseKeyFrameController_ID), null);
	pAddLinesDustRiseDownPartController.SetControlParameters(mpLineGroupViewports[1], componentPosition);

	TetrisApp.StartAndInitializeTimeSystem(mpAddLinesTimeSystem);


}


public void StartHardDropAnim ( Tetrimino pFallingTetrimino, int fallingHeigth) {


	
	mCurrentAnimation = kHardDropAnimation;


	SwitchMinosParentUnderTetrimino(true, pFallingTetrimino);
	mpHardDropTetrimino = pFallingTetrimino;

	TetrisApp.StartAndInitializeTimeSystem(mpHardDropReboundTimeSystem);
SetHardDropTrailSprite(pFallingTetrimino);

	 int hardDropTrailInitTime = (((int)ConstantsEnglishPortrait.hardDropTrailFrameOneTimeIndex == (int)ConstantsEnglishLandscape.hardDropTrailFrameOneTimeIndex) ? Constants.hardDropTrailFrameOneTimeIndex : ConstantsGetter.GetConstants().hardDropTrailFrameOneTimeIndexFct());


	if(fallingHeigth <= (((int)ConstantsEnglishPortrait.hardDropTrailZeroLengthLimit == (int)ConstantsEnglishLandscape.hardDropTrailZeroLengthLimit) ? Constants.hardDropTrailZeroLengthLimit : ConstantsGetter.GetConstants().hardDropTrailZeroLengthLimitFct()))
	{
		hardDropTrailInitTime = (((int)ConstantsEnglishPortrait.hardDropTrailPeriod == (int)ConstantsEnglishLandscape.hardDropTrailPeriod) ? Constants.hardDropTrailPeriod : ConstantsGetter.GetConstants().hardDropTrailPeriodFct());
	}
	else if(fallingHeigth <= (((int)ConstantsEnglishPortrait.hardDropTrailSmallLengthLimit == (int)ConstantsEnglishLandscape.hardDropTrailSmallLengthLimit) ? Constants.hardDropTrailSmallLengthLimit : ConstantsGetter.GetConstants().hardDropTrailSmallLengthLimitFct()))
	{
		hardDropTrailInitTime = (((int)ConstantsEnglishPortrait.hardDropTrailFrameThreeTimeIndex == (int)ConstantsEnglishLandscape.hardDropTrailFrameThreeTimeIndex) ? Constants.hardDropTrailFrameThreeTimeIndex : ConstantsGetter.GetConstants().hardDropTrailFrameThreeTimeIndexFct());
	}
	else if(fallingHeigth <= (((int)ConstantsEnglishPortrait.hardDropTrailMediumLengthLimit == (int)ConstantsEnglishLandscape.hardDropTrailMediumLengthLimit) ? Constants.hardDropTrailMediumLengthLimit : ConstantsGetter.GetConstants().hardDropTrailMediumLengthLimitFct()))
	{
		hardDropTrailInitTime = (((int)ConstantsEnglishPortrait.hardDropTrailFrameTwoTimeIndex == (int)ConstantsEnglishLandscape.hardDropTrailFrameTwoTimeIndex) ? Constants.hardDropTrailFrameTwoTimeIndex : ConstantsGetter.GetConstants().hardDropTrailFrameTwoTimeIndexFct());
	}

	TetrisApp.StartAndInitializeTimeSystem(mpHardDropTrailTimeSystem, hardDropTrailInitTime);
mpWellState.SetDoingAnimation(true);

}


public void StopAllAnimations () {


	if(mCurrentAnimation == kClearLinesAnimation)
	{
		StopClearLinesAnimation();
	}
	else if(mCurrentAnimation == kAddLinesAnimation)
	{
		StopAddLinesAnimation();
	}

	else if(mCurrentAnimation == kHardDropAnimation)
	{
		StopHardDropAnim();
	}
mDisplayingTetriminoLocked = false;
	mDisplayingClearedLines = false;

}


public void SetClearLineAnimDisabled(boolean clearLineAnimDisabled) {
 mClearLineAnimDisabled = clearLineAnimDisabled; 
}


public final static int kNoAnimation = 0;
public final static int kClearLinesAnimation = 1;
public final static int kAddLinesAnimation = 2;
public final static int kHardDropAnimation = 3;

public void SynchWithState () {

	for(int row = 0;row < (((int)ConstantsEnglishPortrait.wellVisibleHeight == (int)ConstantsEnglishLandscape.wellVisibleHeight) ? Constants.wellVisibleHeight : ConstantsGetter.GetConstants().wellVisibleHeightFct());row ++)
	{
		mpLines[row].Update();
	}
	Invalidate();

}


public void RunPhaseLockedNormal (int deltaTimeMs) {

	if(mDisplayingTetriminoLocked)
	{
		if(!mpWellState.IsDoingAnimation() && (HasClearedLines() || HasAddedLines()))
		{
			mpWellState.SetDoingAnimation(true);
		}
		mDisplayTetriminoLockedTimer += deltaTimeMs;
		if(mDisplayTetriminoLockedTimer >= (((int)ConstantsEnglishPortrait.tetriminoLockedDisplayTime == (int)ConstantsEnglishLandscape.tetriminoLockedDisplayTime) ? Constants.tetriminoLockedDisplayTime : ConstantsGetter.GetConstants().tetriminoLockedDisplayTimeFct()))
		{
			mDisplayingTetriminoLocked = false;
		}
	}
	else
	{
		mDisplayingTetriminoLocked = true;
		mDisplayTetriminoLockedTimer = 0;
		SynchWithState(); 
	}

}


public void RunPhaseClearedLinesNormal (int deltaTimeMs) {

	if(mDisplayingClearedLines)
	{
		if(!mpWellState.IsDoingAnimation() && HasAddedLines())
		{
			mpWellState.SetDoingAnimation(true);
		}
		mDisplayClearedLinesTimer += deltaTimeMs;
		if(mDisplayClearedLinesTimer >= (((int)ConstantsEnglishPortrait.clearLinesDisplayTime == (int)ConstantsEnglishLandscape.clearLinesDisplayTime) ? Constants.clearLinesDisplayTime : ConstantsGetter.GetConstants().clearLinesDisplayTimeFct()))
		{
			mDisplayingClearedLines = false;
		}
	}
	else
	{
		mpWellState.SetDoingAnimation(false);
		if(HasClearedLines())
		{
			mDisplayingClearedLines = true;
			mDisplayClearedLinesTimer = 0;
			SynchWithState(); 
		}
	}

}


public void RunPhaseAddedLinesNormal () {

	mpWellState.SetDoingAnimation(false);
	if(HasAddedLines())
	{
		SynchWithState(); 
	}

}


public boolean HasClearedLines () {

	return  mpWellState.GetClearedLineCountFromFlags(mpWellState.GetLastShotClearedLineFlags()) > 0;

}


public boolean HasAddedLines () {

	return  mpWellState.GetLastShotAddedLineCount() > 0;

}


public void RunPhaseClearedLinesAnim () {

	if(mCurrentAnimation == kNoAnimation)
	{
		mpWellState.SetDoingAnimation(false);
		CheckForClearLinesAnimation(); 
	}
	else if(mCurrentAnimation == kClearLinesAnimation)
	{
		if(!mpWellState.IsDoingAnimation() && HasAddedLines())
		{
			mpWellState.SetDoingAnimation(true);
		}
	}

}


public void RunPhaseAddedLinesAnim () {

	if(mCurrentAnimation == kNoAnimation)
	{
		mpWellState.SetDoingAnimation(false);
		if(mpWellState.GetLastShotAddedLineCount() > 0)
		{
			SynchWithState(); 
			StartAddLinesAnimation();
		}
	}

}


public void StopHardDropAnim () {



	mCurrentAnimation = kNoAnimation;


	TetrisApp.FinalizeAndStopTimeSystem(mpHardDropReboundTimeSystem);
	SwitchMinosParentUnderTetrimino(false, mpHardDropTetrimino);
	mpHardDropTetrimino = null;
mpHardDropTrailTimeSystem.Stop();

	for(int i = 0;i < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());i ++)
	{
		mpHardDropTrailSprite[i].SetVisible(false);
	}
mpWellState.SetDoingAnimation(false);

}


public void SwitchMinosParentUnderTetrimino (boolean toWell, Tetrimino pTetrimino) {

	for(int mino = 0;mino < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());mino ++)
	{
		 int minoMatrixX = pTetrimino.GetMatrixPosX() + pTetrimino.GetMinoX(mino);

		 int minoMatrixY = pTetrimino.GetMatrixPosY() + pTetrimino.GetMinoY(mino);


		if(minoMatrixY + 1< (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) && mpWellState.IsBlockUsed(minoMatrixX, minoMatrixY + 1))
		{
			 int uiRow = minoMatrixY + 1- (((int)ConstantsEnglishPortrait.wellSkyline == (int)ConstantsEnglishLandscape.wellSkyline) ? Constants.wellSkyline : ConstantsGetter.GetConstants().wellSkylineFct());

			if(uiRow >= 0)
			{
				SwitchMinoParent(toWell, uiRow, minoMatrixX);

				mpHardDropReboundControllers[mino].SetControllee(toWell ? mpLines[uiRow].GetMino(minoMatrixX) : null);
			}
		}
	}

}


public void SwitchMinoParent (boolean toWell, int row, int col) {



	 MinoSprite pMino = mpLines[row].GetMino(col);
	if(toWell)
	{


		pMino.SetViewport(this);
		pMino.SetTopLeft((short)(pMino.GetRectLeft() + mpLines[row].GetRectLeft()), (short)(pMino.GetRectTop() + mpLines[row].GetRectTop()));
	}
	else
	{


		pMino.SetViewport(mpLines[row]);
		pMino.SetTopLeft((short)(pMino.GetRectLeft() - mpLines[row].GetRectLeft()), (short)(pMino.GetRectTop() - mpLines[row].GetRectTop()));
	}

}


public void SetHardDropTrailSprite ( Tetrimino pTetrimino) {

	 int minoMatrixX = 0;

	 int minoMatrixY = 0;

	 int uiRow = 0;


	 MinoSprite pMino = null;

	for(int mino = 0;mino < (((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : ConstantsGetter.GetConstants().minosPerTetriminoFct());mino ++)
	{
		minoMatrixY = pTetrimino.GetMatrixPosY() + pTetrimino.GetMinoY(mino);
		uiRow = minoMatrixY - (((int)ConstantsEnglishPortrait.wellSkyline == (int)ConstantsEnglishLandscape.wellSkyline) ? Constants.wellSkyline : ConstantsGetter.GetConstants().wellSkylineFct());

		
		if((pTetrimino.GetSticky(mino, (int)pTetrimino.GetFacingDir()) & 8) == 0&& uiRow >= 0)
		{
			minoMatrixX = pTetrimino.GetMatrixPosX() + pTetrimino.GetMinoX(mino);
			pMino = mpLines[uiRow].GetMino(minoMatrixX);

			mpHardDropTrailSprite[mino].SetTopLeft((short)(pMino.GetRectLeft() + mpLines[uiRow].GetRectLeft()), (short)(pMino.GetRectTop() + mpLines[uiRow].GetRectTop() - (((int)ConstantsEnglishPortrait.hardDropTrailFullHeight == (int)ConstantsEnglishLandscape.hardDropTrailFullHeight) ? Constants.hardDropTrailFullHeight : ConstantsGetter.GetConstants().hardDropTrailFullHeightFct())));
			
			
			mpHardDropTrailSprite[mino].SetBitmap(mpHardDropTrailBitmap[pTetrimino.GetMinoColor()]);
			mpHardDropTrailSprite[mino].SetVisible(true);

			
			mpHardDropTrailPosController[mino].SetIsAbsolute(true);
			mpHardDropTrailPosController[mino].SetIsAbsolute(false);

		}
		else
		{
			mpHardDropTrailSprite[mino].SetVisible(false);
		}
	}

}


public void CheckForEndOfAnimations () {

	if(mCurrentAnimation == kClearLinesAnimation)
	{
		if((mpFallTimerSequence.IsPaused() || mpFallTimerSequence.GetTotalTime() >= mFallDuration) && (mpClear1LineTimeSystem.IsPaused() || mpClear1LineTimeSystem.GetTotalTime() >= (((int)ConstantsEnglishPortrait.minoClear1LinePeriod == (int)ConstantsEnglishLandscape.minoClear1LinePeriod) ? Constants.minoClear1LinePeriod : ConstantsGetter.GetConstants().minoClear1LinePeriodFct())) && (mpClear2LinesTimeSystem.IsPaused() || mpClear2LinesTimeSystem.GetTotalTime() >= (((int)ConstantsEnglishPortrait.minoClear2LinesPeriod == (int)ConstantsEnglishLandscape.minoClear2LinesPeriod) ? Constants.minoClear2LinesPeriod : ConstantsGetter.GetConstants().minoClear2LinesPeriodFct())) && (mpClear3LinesTimeSystem.IsPaused() || mpClear3LinesTimeSystem.GetTotalTime() >= (((int)ConstantsEnglishPortrait.minoClear3LinesPeriod == (int)ConstantsEnglishLandscape.minoClear3LinesPeriod) ? Constants.minoClear3LinesPeriod : ConstantsGetter.GetConstants().minoClear3LinesPeriodFct())) && (mpClear4LinesTimerSequence.IsPaused() || mpClear4LinesTimerSequence.GetTotalTime() >= (((int)ConstantsEnglishPortrait.minoClear4LinesTotalPeriod == (int)ConstantsEnglishLandscape.minoClear4LinesTotalPeriod) ? Constants.minoClear4LinesTotalPeriod : ConstantsGetter.GetConstants().minoClear4LinesTotalPeriodFct())))
		{
			StopClearLinesAnimation();
		}
	}
	else if(mCurrentAnimation == kAddLinesAnimation)
	{
		if(!mpAddLinesTimeSystem.IsPaused() && mpAddLinesTimeSystem.GetTotalTime() >= (((int)ConstantsEnglishPortrait.minoAddLinesTotalPeriod == (int)ConstantsEnglishLandscape.minoAddLinesTotalPeriod) ? Constants.minoAddLinesTotalPeriod : ConstantsGetter.GetConstants().minoAddLinesTotalPeriodFct()))
		{
			StopAddLinesAnimation();
		}
	}

	else if(mCurrentAnimation == kHardDropAnimation)
	{

		if(!mpHardDropReboundTimeSystem.IsPaused() && mpHardDropReboundTimeSystem.GetTotalTime() >= (((int)ConstantsEnglishPortrait.minoHardDropReboundDuration == (int)ConstantsEnglishLandscape.minoHardDropReboundDuration) ? Constants.minoHardDropReboundDuration : ConstantsGetter.GetConstants().minoHardDropReboundDurationFct()))
{

			if(!mpHardDropTrailTimeSystem.IsPaused() && mpHardDropTrailTimeSystem.GetTotalTime() >= (((int)ConstantsEnglishPortrait.hardDropTrailPeriod == (int)ConstantsEnglishLandscape.hardDropTrailPeriod) ? Constants.hardDropTrailPeriod : ConstantsGetter.GetConstants().hardDropTrailPeriodFct()))
{
				StopHardDropAnim();
			}
		}
	}

}


public void CheckForClearLinesAnimation () {

	int[] fallStartTimes = { (((int)ConstantsEnglishPortrait.minoClear1LineFallStartTime == (int)ConstantsEnglishLandscape.minoClear1LineFallStartTime) ? Constants.minoClear1LineFallStartTime : ConstantsGetter.GetConstants().minoClear1LineFallStartTimeFct()), (((int)ConstantsEnglishPortrait.minoClear2LinesFallStartTime == (int)ConstantsEnglishLandscape.minoClear2LinesFallStartTime) ? Constants.minoClear2LinesFallStartTime : ConstantsGetter.GetConstants().minoClear2LinesFallStartTimeFct()), (((int)ConstantsEnglishPortrait.minoClear3LinesFallStartTime == (int)ConstantsEnglishLandscape.minoClear3LinesFallStartTime) ? Constants.minoClear3LinesFallStartTime : ConstantsGetter.GetConstants().minoClear3LinesFallStartTimeFct()), (((int)ConstantsEnglishPortrait.minoClear4LinesFallStartTime == (int)ConstantsEnglishLandscape.minoClear4LinesFallStartTime) ? Constants.minoClear4LinesFallStartTime : ConstantsGetter.GetConstants().minoClear4LinesFallStartTimeFct()) };
	 int clearedLineFlags = mpWellState.GetLastShotClearedLineFlags();

	 int totalLinesCleared = Well.GetClearedLineCountFromFlags(clearedLineFlags);

	 int consecutiveLinesCleared = 0;

	 int firstRowInGroup = 0;

	 int lineGroupIndex = 0;

	 int clashClearLines = (((int)ConstantsEnglishPortrait.clashNoClear == (int)ConstantsEnglishLandscape.clashNoClear) ? Constants.clashNoClear : ConstantsGetter.GetConstants().clashNoClearFct());









for(int stateRow = (((int)ConstantsEnglishPortrait.wellSkyline == (int)ConstantsEnglishLandscape.wellSkyline) ? Constants.wellSkyline : ConstantsGetter.GetConstants().wellSkylineFct());stateRow < (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct());stateRow ++)
	{
		if(Well.IsClearedLineFromFlags(clearedLineFlags, stateRow))
		{
			consecutiveLinesCleared++;
		}
		else if(consecutiveLinesCleared > 0)
		{
			 int uiRow = stateRow - (((int)ConstantsEnglishPortrait.wellSkyline == (int)ConstantsEnglishLandscape.wellSkyline) ? Constants.wellSkyline : ConstantsGetter.GetConstants().wellSkylineFct());

			 int clearLineFirstRow = uiRow - consecutiveLinesCleared;



			if(mClearLineAnimDisabled) 
			{
				Update();
			}
			else 
{
				StartFallAnimation(firstRowInGroup, clearLineFirstRow - 1, lineGroupIndex, totalLinesCleared, fallStartTimes[consecutiveLinesCleared - 1]);
				StartClearLinesAnimation(consecutiveLinesCleared, clearLineFirstRow, clashClearLines);
			}
			totalLinesCleared -= consecutiveLinesCleared;
			consecutiveLinesCleared = 0;
			firstRowInGroup = uiRow;
			lineGroupIndex++;
		}
	}
	if(consecutiveLinesCleared > 0)
	{
		 int uiRow = (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - (((int)ConstantsEnglishPortrait.wellSkyline == (int)ConstantsEnglishLandscape.wellSkyline) ? Constants.wellSkyline : ConstantsGetter.GetConstants().wellSkylineFct());

		 int clearLineFirstRow = uiRow - consecutiveLinesCleared;



		if(mClearLineAnimDisabled) 
		{
			Update();
		}
		else 
{
			StartFallAnimation(firstRowInGroup, clearLineFirstRow - 1, lineGroupIndex, totalLinesCleared, fallStartTimes[consecutiveLinesCleared - 1]);
			StartClearLinesAnimation(consecutiveLinesCleared, clearLineFirstRow, clashClearLines);
		}
	}

}


public void StartClearLinesAnimation (int lineCount, int firstRow, int clashClearLine) {






	 int firstRowTop = firstRow * mMinoSize;

	 int offset = 0;
 
	 int controllerOffset = 0;
 

	 short lastShotTSpinX = mpWellState.GetLastShotTSpinX();

	 short lastShotTSpinY = (short)(mpWellState.GetLastShotTSpinY() - (((int)ConstantsEnglishPortrait.wellSkyline == (int)ConstantsEnglishLandscape.wellSkyline) ? Constants.wellSkyline : ConstantsGetter.GetConstants().wellSkylineFct()));


	mCurrentAnimation = kClearLinesAnimation;

	switch(lineCount)
	{
	case 1 :
		{
			
			if(mpClear1LineTimeSystem.IsPaused())
			{
				
				mpClear1LineMultiDisplay.BringToFront();
				mpClear1LineMultiDisplay.SetTopLeft(mpClear1LineMultiDisplay.GetRectLeft(), (short)(firstRowTop));
			}
			else
			{
				
				offset = (firstRowTop - mpClear1LineMultiDisplay.GetRectTop()) / mMinoSize;
				controllerOffset = 1;
			}

			if(mpWellState.IsLastShotTSpin())
			{

				if(lastShotTSpinY == firstRow)
				{
					for(int i = 0;i < (((int)ConstantsEnglishPortrait.minoClear1LineTSpinMaxMinoCount == (int)ConstantsEnglishLandscape.minoClear1LineTSpinMaxMinoCount) ? Constants.minoClear1LineTSpinMaxMinoCount : ConstantsGetter.GetConstants().minoClear1LineTSpinMaxMinoCountFct());i ++)
					{
						 Component clearLineMino = ((Viewport)mpClear1LineMultiDisplay.GetChild()).GetChild(lastShotTSpinX + i - 1);
						mpClear1LineTSpinController[i].SetControlParameters(clearLineMino, indexedSpriteFrame);
					}
				}
				else
				{

					 Component clearLineMino = ((Viewport)mpClear1LineMultiDisplay.GetChild()).GetChild(lastShotTSpinX);
					mpClear1LineTSpinController[0].SetControlParameters(clearLineMino, indexedSpriteFrame);
				}
			}

			UpdateClearLineBitmapGroup((Viewport)mpClear1LineMultiDisplay.GetChild());


			InitializeHideControllers(mpClear1LineHideController, controllerOffset, firstRow, lineCount, componentVisibility);

			for(int i = 0;i < lineCount;i ++)
			{
				 int row = i + offset;


				mpClear1LineMultiDisplay.AddPosition(new Vector2_short((short)0, (short)(row * mMinoSize)));
			}

			TetrisApp.StartAndInitializeTimeSystem(mpClear1LineTimeSystem);
		}
		break;

	case 2 :
		
		mpClear2LinesViewport.BringToFront();
		mpClear2LinesViewport.SetTopLeft(mpClear2LinesViewport.GetRectLeft(), (short)(firstRowTop));
		mpClear2LinesViewport.SetVisible(true);

		if(mpWellState.IsLastShotTSpin())
		{

			for(int i = 0;i < (((int)ConstantsEnglishPortrait.minoClear2LinesTSpinFirstRowMinoCount == (int)ConstantsEnglishLandscape.minoClear2LinesTSpinFirstRowMinoCount) ? Constants.minoClear2LinesTSpinFirstRowMinoCount : ConstantsGetter.GetConstants().minoClear2LinesTSpinFirstRowMinoCountFct());i ++)
			{
				 Component clearLineMino = mpClear2LinesViewport.GetChild(lastShotTSpinX + i - 1);
				mpClear2LinesTSpinController[i].SetControlParameters(clearLineMino, indexedSpriteFrame);
			}

			 Component clearLineMino = mpClear2LinesViewport.GetChild((((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()) + lastShotTSpinX);
			mpClear2LinesTSpinController[(((int)ConstantsEnglishPortrait.minoClear2LinesTSpinFirstRowMinoCount == (int)ConstantsEnglishLandscape.minoClear2LinesTSpinFirstRowMinoCount) ? Constants.minoClear2LinesTSpinFirstRowMinoCount : ConstantsGetter.GetConstants().minoClear2LinesTSpinFirstRowMinoCountFct())].SetControlParameters(clearLineMino, indexedSpriteFrame);
		}

		UpdateClearLineBitmapGroup(mpClear2LinesViewport);

		InitializeHideControllers(mpClear2LinesHideController, 0, firstRow, lineCount, componentVisibility);

		TetrisApp.StartAndInitializeTimeSystem(mpClear2LinesTimeSystem);
		break;

	case 3 :
		
		mpClear3LinesMultiDisplay.BringToFront();
		mpClear3LinesMultiDisplay.SetTopLeft(mpClear3LinesMultiDisplay.GetRectLeft(), (short)(firstRowTop));
		mpClear3LinesMultiDisplay.SetVisible(true);

		mpClear3LinesLightningViewport.SetVisible(true);
		mpClear3LinesLightningViewport.SetTopLeft(mpClear3LinesLightningViewport.GetRectLeft(), (short)(firstRowTop));

		UpdateClearLineBitmapGroup((Viewport)mpClear3LinesMultiDisplay.GetChild());

		InitializeHideControllers(mpClear3LinesHideController, 0, firstRow, lineCount, componentVisibility);

		TetrisApp.StartAndInitializeTimeSystem(mpClear3LinesTimeSystem);
		break;

	case 4 :















{
			
			mpClear4LinesMultiDisplay.BringToFront();
			mpClear4LinesMultiDisplay.SetTopLeft(mpClear4LinesMultiDisplay.GetRectLeft(), (short)(firstRowTop));
			mpClear4LinesMultiDisplay.SetVisible(true);

			UpdateClearLineBitmapGroup((Viewport)mpClear4LinesMultiDisplay.GetChild());

			InitializeHideControllers(mpClear4LinesHideController, 0, firstRow, lineCount, (((int)ConstantsEnglishPortrait.minoClearLinesHide == (int)ConstantsEnglishLandscape.minoClearLinesHide) ? Constants.minoClearLinesHide : ConstantsGetter.GetConstants().minoClearLinesHideFct()));

			TetrisApp.StartAndInitializeTimeSystem(mpClear4LinesTimerSequence);
			TetrisApp.StartAndInitializeTimeSystem(mpClear4LinesHideTimeSystem);
		}
		
		break;
	}

}


public void StopClearLinesAnimation () {




	
	InvalidateClearLinesAnimation();
if(!mpClear1LineTimeSystem.IsPaused())
	{
		mpClear1LineMultiDisplay.ClearAllPositions();

		TetrisApp.FinalizeAndStopTimeSystem(mpClear1LineTimeSystem);

		for(int i = 0;i < (((int)ConstantsEnglishPortrait.minoClear1LineTSpinMaxMinoCount == (int)ConstantsEnglishLandscape.minoClear1LineTSpinMaxMinoCount) ? Constants.minoClear1LineTSpinMaxMinoCount : ConstantsGetter.GetConstants().minoClear1LineTSpinMaxMinoCountFct());i ++)
		{
			mpClear1LineTSpinController[i].SetControlParameters(null, indexedSpriteFrame);
		}

		FinalizeHideControllers(mpClear1LineHideController, (((int)ConstantsEnglishPortrait.minoClear1LineMaximumLineCount == (int)ConstantsEnglishLandscape.minoClear1LineMaximumLineCount) ? Constants.minoClear1LineMaximumLineCount : ConstantsGetter.GetConstants().minoClear1LineMaximumLineCountFct()), componentVisibility);
	}

	if(!mpClear2LinesTimeSystem.IsPaused())
	{
		mpClear2LinesViewport.SetVisible(false);

		TetrisApp.FinalizeAndStopTimeSystem(mpClear2LinesTimeSystem);

		for(int i = 0;i < (((int)ConstantsEnglishPortrait.minoClear2LinesTSpinMinoCount == (int)ConstantsEnglishLandscape.minoClear2LinesTSpinMinoCount) ? Constants.minoClear2LinesTSpinMinoCount : ConstantsGetter.GetConstants().minoClear2LinesTSpinMinoCountFct());i ++)
		{
			mpClear2LinesTSpinController[i].SetControlParameters(null, indexedSpriteFrame);
		}

		FinalizeHideControllers(mpClear2LinesHideController, (((int)ConstantsEnglishPortrait.minoClear2LinesMaximumLineCount == (int)ConstantsEnglishLandscape.minoClear2LinesMaximumLineCount) ? Constants.minoClear2LinesMaximumLineCount : ConstantsGetter.GetConstants().minoClear2LinesMaximumLineCountFct()), componentVisibility);
	}

	if(!mpClear3LinesTimeSystem.IsPaused())
	{
		mpClear3LinesMultiDisplay.SetVisible(false);
		mpClear3LinesLightningViewport.SetVisible(false);

		TetrisApp.FinalizeAndStopTimeSystem(mpClear3LinesTimeSystem, (((int)ConstantsEnglishPortrait.minoClear3LinesHideSetVisibleTrueTime == (int)ConstantsEnglishLandscape.minoClear3LinesHideSetVisibleTrueTime) ? Constants.minoClear3LinesHideSetVisibleTrueTime : ConstantsGetter.GetConstants().minoClear3LinesHideSetVisibleTrueTimeFct()));

		FinalizeHideControllers(mpClear3LinesHideController, (((int)ConstantsEnglishPortrait.minoClear3LinesMaximumLineCount == (int)ConstantsEnglishLandscape.minoClear3LinesMaximumLineCount) ? Constants.minoClear3LinesMaximumLineCount : ConstantsGetter.GetConstants().minoClear3LinesMaximumLineCountFct()), componentVisibility);
	}

	if(!mpClear4LinesTimerSequence.IsPaused())
	{
		mpClear4LinesMultiDisplay.SetVisible(false);

		mpClear4LinesTimerSequence.Stop();

		FinalizeHideControllers(mpClear4LinesHideController, (((int)ConstantsEnglishPortrait.minoClear4LinesMaximumLineCount == (int)ConstantsEnglishLandscape.minoClear4LinesMaximumLineCount) ? Constants.minoClear4LinesMaximumLineCount : ConstantsGetter.GetConstants().minoClear4LinesMaximumLineCountFct()), (((int)ConstantsEnglishPortrait.minoClearLinesHide == (int)ConstantsEnglishLandscape.minoClearLinesHide) ? Constants.minoClearLinesHide : ConstantsGetter.GetConstants().minoClearLinesHideFct()));
	}








if(!mpFallTimerSequence.IsPaused())
	{
		for(int i = 0;i < MAX_LINE_GROUP_COUNT;i ++)
		{
			if(mpFallTimerSequence.IsRegistered(mpFallControllers[i]))
			{
				StopFallAnimation(i);
			}
		}
	}

	mCurrentAnimation = kNoAnimation;

	SynchWithState();
	mpWellState.SetDoingAnimation(false);

}


public void InvalidateClearLinesAnimation () {

	if(mCurrentAnimation == kClearLinesAnimation)
	{
		if(!mpClear1LineTimeSystem.IsPaused())
		{
			mpClear1LineMultiDisplay.Invalidate();
		}
		if(!mpClear3LinesTimeSystem.IsPaused())
		{
			mpClear3LinesMultiDisplay.Invalidate();
		}
		if(!mpClear4LinesTimerSequence.IsPaused())
		{
			mpClear4LinesMultiDisplay.Invalidate();
		}
	}

}


public void StartFallAnimation (int firstRow, int lastRow, int lineGroupIndex, int numRowToFall, int startTimeMs) {

	if(lastRow >= firstRow) 
	{
		 Package pGameScenePackage = RessourcesManager.Get().GetPackage(PackageID.gameScene, false);

		MakeLineGroup(firstRow, lastRow, lineGroupIndex);


		 KeyFrameSequence pKeyFrameSequence = null;
		(pKeyFrameSequence)= (pKeyFrameSequence).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoFall1KeyFrameSequence_ID + numRowToFall - 1), null);

		mpFallControllers[lineGroupIndex].SetKeySequence(pKeyFrameSequence);

		
		mpFallControllers[lineGroupIndex].SetIsAbsolute(true);
		mpFallControllers[lineGroupIndex].SetIsAbsolute(false);



		mpFallTimerSequence.RegisterInterval(mpFallControllers[lineGroupIndex], startTimeMs - (((int)ConstantsEnglishPortrait.minoFallBlankTime == (int)ConstantsEnglishLandscape.minoFallBlankTime) ? Constants.minoFallBlankTime : ConstantsGetter.GetConstants().minoFallBlankTimeFct()), (((int)ConstantsEnglishPortrait.minoFallBlankTime == (int)ConstantsEnglishLandscape.minoFallBlankTime) ? Constants.minoFallBlankTime : ConstantsGetter.GetConstants().minoFallBlankTimeFct()) + (((int)ConstantsEnglishPortrait.minoFallDuration == (int)ConstantsEnglishLandscape.minoFallDuration) ? Constants.minoFallDuration : ConstantsGetter.GetConstants().minoFallDurationFct()));

		TetrisApp.StartAndInitializeTimeSystem(mpFallTimerSequence);

		 int fallDuration = startTimeMs + (((int)ConstantsEnglishPortrait.minoFallDuration == (int)ConstantsEnglishLandscape.minoFallDuration) ? Constants.minoFallDuration : ConstantsGetter.GetConstants().minoFallDurationFct());

		if(fallDuration > mFallDuration)
		{
			mFallDuration = fallDuration;
		}
	}

}


public void StopFallAnimation (int lineGroupIndex) {

	
	if(!mpFallTimerSequence.IsPaused())
	{
		TetrisApp.FinalizeAndStopTimeSystem(mpFallTimerSequence);

		mFallDuration = 0;
	}


	mpFallTimerSequence.UnRegister(mpFallControllers[lineGroupIndex]);

	DestroyLineGroup(lineGroupIndex);

}


public void MakeLineGroup (int firstRow, int lastRow, int lineGroupIndex) {




	mpLineGroupViewports[lineGroupIndex].SetRect(mpLines[firstRow].GetRectLeft(), mpLines[firstRow].GetRectTop(), mpLines[firstRow].GetRectWidth(), (short)(mMinoSize * (lastRow - firstRow + 1)));

	for(int i = firstRow;i <= lastRow;i ++)
	{

		mpLines[i].SetViewport(mpLineGroupViewports[lineGroupIndex]);
		mpLines[i].SetTopLeft((short)0, (short)(mpLines[i].GetRectTop() - mpLineGroupViewports[lineGroupIndex].GetRectTop()));
	}

}


public void DestroyLineGroup (int lineGroupIndex) {



	 int childCount = mpLineGroupViewports[lineGroupIndex].GetChildCount();

	for(int i = 0;i < childCount;i ++)
	{
		 Component child = mpLineGroupViewports[lineGroupIndex].GetChild(0); 
		child.SetViewport(this);
		child.SetTopLeft(mpLineGroupViewports[lineGroupIndex].GetRectLeft(), (short)(mpLineGroupViewports[lineGroupIndex].GetRectTop() + child.GetRectTop()));
	}

}


public void StopAddLinesAnimation () {



	mCurrentAnimation = kNoAnimation;

	mpAddLinesDustViewport.SetVisible(false);

	TetrisApp.FinalizeAndStopTimeSystem(mpAddLinesTimeSystem, (((int)ConstantsEnglishPortrait.minoAddLinesTotalPeriod == (int)ConstantsEnglishLandscape.minoAddLinesTotalPeriod) ? Constants.minoAddLinesTotalPeriod : ConstantsGetter.GetConstants().minoAddLinesTotalPeriodFct()));

	DestroyLineGroup(0);
	DestroyLineGroup(1);

	mpWellState.SetDoingAnimation(false);

}


public void InitializeHideControllers (KeyFrameController[] hideControllers, int offset, int firstRow, int lineCount, int controlledValue) {

	for(int i = 0;i < lineCount;i ++)
	{
		 int row = i + offset;


		hideControllers[row].SetControlParameters(mpLines[firstRow + i], controlledValue);
	}

}


public void FinalizeHideControllers (KeyFrameController[] hideControllers, int lineCount, int controlledValue) {

	for(int i = 0;i < lineCount;i ++)
	{
		hideControllers[i].SetControlParameters(null, controlledValue);
	}

}


public void UpdateClearLineBitmapGroup (Viewport pClearLineViewport) {

	 Package pGameScenePackage = RessourcesManager.Get().GetPackage(PackageID.gameScene, false);
	 BitmapGroup pBitmapGroup = null;

	if(mpWellState.GetLastShotBackToBack())
	{
		(pBitmapGroup)= (pBitmapGroup).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoClearBackToBackBitmapGroup_ID), null);
	}
	else
	{
		(pBitmapGroup)= (pBitmapGroup).Cast((pGameScenePackage).GetEntryPoint(RSRC_gameScenePackage.minoClearBitmapGroup_ID), null);
	}

	 Component child = pClearLineViewport.GetChild(0);

	while(child != null)
	{

		
		((IndexedSprite)child).SetBitmapGroup(pBitmapGroup);
		child = child.GetPreviousSiblingComponent();
	}

}


public static TetrisApp GetApp () {

	return  TetrisApp.Get();

}


public WellLineComponent[] mpLines = new WellLineComponent[(((int)ConstantsEnglishPortrait.wellVisibleHeight == (int)ConstantsEnglishLandscape.wellVisibleHeight) ? Constants.wellVisibleHeight : -123)];

public Well mpWellState;
public int mUIGamePhase;
public boolean mMainWell;
public int mMinoSize;
public boolean mDisplayingTetriminoLocked;
public int mDisplayTetriminoLockedTimer;
public boolean mDisplayingClearedLines;
public int mDisplayClearedLinesTimer;
public boolean mAnimatingWhileTetriminoFalling;
public MultiDisplayComponent mpClear1LineMultiDisplay;
public TimeSystem mpClear1LineTimeSystem;
public KeyFrameController[] mpClear1LineTSpinController = new KeyFrameController[(((int)ConstantsEnglishPortrait.minoClear1LineTSpinMaxMinoCount == (int)ConstantsEnglishLandscape.minoClear1LineTSpinMaxMinoCount) ? Constants.minoClear1LineTSpinMaxMinoCount : -123)];

public KeyFrameController[] mpClear1LineHideController = new KeyFrameController[(((int)ConstantsEnglishPortrait.minoClear1LineMaximumLineCount == (int)ConstantsEnglishLandscape.minoClear1LineMaximumLineCount) ? Constants.minoClear1LineMaximumLineCount : -123)];

public Viewport mpClear2LinesViewport;
public TimeSystem mpClear2LinesTimeSystem;
public KeyFrameController[] mpClear2LinesTSpinController = new KeyFrameController[(((int)ConstantsEnglishPortrait.minoClear2LinesTSpinMinoCount == (int)ConstantsEnglishLandscape.minoClear2LinesTSpinMinoCount) ? Constants.minoClear2LinesTSpinMinoCount : -123)];

public KeyFrameController[] mpClear2LinesHideController = new KeyFrameController[(((int)ConstantsEnglishPortrait.minoClear2LinesMaximumLineCount == (int)ConstantsEnglishLandscape.minoClear2LinesMaximumLineCount) ? Constants.minoClear2LinesMaximumLineCount : -123)];

public MultiDisplayComponent mpClear3LinesMultiDisplay;
public Viewport mpClear3LinesLightningViewport;
public TimeSystem mpClear3LinesTimeSystem;
public KeyFrameController[] mpClear3LinesHideController = new KeyFrameController[(((int)ConstantsEnglishPortrait.minoClear3LinesMaximumLineCount == (int)ConstantsEnglishLandscape.minoClear3LinesMaximumLineCount) ? Constants.minoClear3LinesMaximumLineCount : -123)];

public MultiDisplayComponent mpClear4LinesMultiDisplay;
public TimerSequence mpClear4LinesTimerSequence;
public TimeSystem mpClear4LinesHideTimeSystem;
public KeyFrameController[] mpClear4LinesHideController = new KeyFrameController[(((int)ConstantsEnglishPortrait.minoClear4LinesMaximumLineCount == (int)ConstantsEnglishLandscape.minoClear4LinesMaximumLineCount) ? Constants.minoClear4LinesMaximumLineCount : -123)];

public int mCurrentAnimation;
public Viewport[] mpLineGroupViewports = new Viewport[MAX_LINE_GROUP_COUNT];

public TimerSequence mpFallTimerSequence;
public int mFallDuration;
public KeyFrameController[] mpFallControllers = new KeyFrameController[MAX_LINE_GROUP_COUNT];

public Viewport mpAddLinesDustViewport;
public TimeSystem mpAddLinesTimeSystem;
public Tetrimino mpHardDropTetrimino;
public KeyFrameController[] mpHardDropReboundControllers = new KeyFrameController[(((int)ConstantsEnglishPortrait.minoHardDropReboundMaxMinoCount == (int)ConstantsEnglishLandscape.minoHardDropReboundMaxMinoCount) ? Constants.minoHardDropReboundMaxMinoCount : -123)];

public TimeSystem mpHardDropReboundTimeSystem;
public Bitmap[] mpHardDropTrailBitmap = new Bitmap[(((int)ConstantsEnglishPortrait.hardDropTrailBitmapCount == (int)ConstantsEnglishLandscape.hardDropTrailBitmapCount) ? Constants.hardDropTrailBitmapCount : -123)];

public Sprite[] mpHardDropTrailSprite = new Sprite[(((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : -123)];

public KeyFrameController[] mpHardDropTrailPosController = new KeyFrameController[(((int)ConstantsEnglishPortrait.minosPerTetrimino == (int)ConstantsEnglishLandscape.minosPerTetrimino) ? Constants.minosPerTetrimino : -123)];

public TimeSystem mpHardDropTrailTimeSystem;
public boolean mClearLineAnimDisabled;
public int mGameOverFillCurrentMino;
public WellComponent(Well wellState, Package pMinoPackage)
{
	this(wellState, pMinoPackage, false);
}



}

